/*
* From: https://github.com/brainboxdotcc/DPP
*/
#pragma once

#include <jsonifier/Index.hpp>

/**
 * @brief Emoji unicodes.
 *
 * @note The unicode emojis in this namespace are auto-generated from https://raw.githubusercontent.com/ArkinSolomon/discord-emoji-converter/master/emojis.json
 *
 * @warning If you want to use this, you have to pull the header in separately. For example:
 * ```cpp
 * #include <dpp/dpp.h>
 * #include <dpp/unicode_emoji.h>
 * ```
 */
namespace unicode_emoji {

	constexpr jsonifier::string_view unicodeEmoji[]{ { "💯" }, { "🔢" }, { "⚽" }, { "⚽" }, { "🏀" }, { "🏈" }, { "⚾" }, { "🥎" }, { "🎾" }, { "🏐" }, { "🏉" }, { "🥏" },
		{ "🎱" }, { "🪀" }, { "🏓" }, { "🏓" }, { "🏸" }, { "🏒" }, { "🏒" }, { "🏑" }, { "🥍" }, { "🏏" }, { "🏏" }, { "🪃" }, { "🥅" }, { "🥅" }, { "⛳" }, { "⛳" }, { "🪁" },
		{ "🛝" }, { "🏹" }, { "🏹" }, { "🎣" }, { "🎣" }, { "🤿" }, { "🥊" }, { "🥊" }, { "🥋" }, { "🥋" }, { "🎽" }, { "🎽" }, { "🛹" }, { "🛼" }, { "🛷" }, { "⛸️" }, { "🥌" },
		{ "🎿" }, { "🎿" }, { "⛷️" }, { "🏂" }, { "🏂🏻" }, { "🏂🏻" }, { "🏂🏼" }, { "🏂🏼" }, { "🏂🏽" }, { "🏂🏽" }, { "🏂🏾" }, { "🏂🏾" }, { "🏂🏿" }, { "🏂🏿" }, { "🪂" },
		{ "🏋️" }, { "🏋️" }, { "🏋️" }, { "🏋🏻" }, { "🏋🏻" }, { "🏋🏻" }, { "🏋🏼" }, { "🏋🏼" }, { "🏋🏼" }, { "🏋🏽" }, { "🏋🏽" }, { "🏋🏽" }, { "🏋🏾" }, { "🏋🏾" },
		{ "🏋🏾" }, { "🏋🏿" }, { "🏋🏿" }, { "🏋🏿" }, { "🏋️‍♀️" }, { "🏋🏻‍♀️" }, { "🏋🏻‍♀️" }, { "🏋🏼‍♀️" }, { "🏋🏼‍♀️" },
		{ "🏋🏽‍♀️" }, { "🏋🏽‍♀️" }, { "🏋🏾‍♀️" }, { "🏋🏾‍♀️" }, { "🏋🏿‍♀️" }, { "🏋🏿‍♀️" },
		{ "🏋️‍♂️" }, { "🏋🏻‍♂️" }, { "🏋🏻‍♂️" }, { "🏋🏼‍♂️" }, { "🏋🏼‍♂️" }, { "🏋🏽‍♂️" },
		{ "🏋🏽‍♂️" }, { "🏋🏾‍♂️" }, { "🏋🏾‍♂️" }, { "🏋🏿‍♂️" }, { "🏋🏿‍♂️" }, { "🤼" }, { "🤼" }, { "🤼" },
		{ "🤼‍♀️" }, { "🤼‍♂️" }, { "🤸" }, { "🤸" }, { "🤸🏻" }, { "🤸🏻" }, { "🤸🏼" }, { "🤸🏼" }, { "🤸🏽" }, { "🤸🏽" }, { "🤸🏾" }, { "🤸🏾" }, { "🤸🏿" },
		{ "🤸🏿" }, { "🤸‍♀️" }, { "🤸🏻‍♀️" }, { "🤸🏻‍♀️" }, { "🤸🏼‍♀️" }, { "🤸🏼‍♀️" }, { "🤸🏽‍♀️" },
		{ "🤸🏽‍♀️" }, { "🤸🏾‍♀️" }, { "🤸🏾‍♀️" }, { "🤸🏿‍♀️" }, { "🤸🏿‍♀️" }, { "🤸‍♂️" }, { "🤸🏻‍♂️" },
		{ "🤸🏻‍♂️" }, { "🤸🏼‍♂️" }, { "🤸🏼‍♂️" }, { "🤸🏽‍♂️" }, { "🤸🏽‍♂️" }, { "🤸🏾‍♂️" },
		{ "🤸🏾‍♂️" }, { "🤸🏿‍♂️" }, { "🤸🏿‍♂️" }, { "⛹️" }, { "⛹️" }, { "⛹️" }, { "⛹🏻" }, { "⛹🏻" }, { "⛹🏻" }, { "⛹🏼" }, { "⛹🏼" }, { "⛹🏼" },
		{ "⛹🏽" }, { "⛹🏽" }, { "⛹🏽" }, { "⛹🏾" }, { "⛹🏾" }, { "⛹🏾" }, { "⛹🏿" }, { "⛹🏿" }, { "⛹🏿" }, { "⛹️‍♀️" }, { "⛹🏻‍♀️" }, { "⛹🏻‍♀️" },
		{ "⛹🏼‍♀️" }, { "⛹🏼‍♀️" }, { "⛹🏽‍♀️" }, { "⛹🏽‍♀️" }, { "⛹🏾‍♀️" }, { "⛹🏾‍♀️" }, { "⛹🏿‍♀️" },
		{ "⛹🏿‍♀️" }, { "⛹️‍♂️" }, { "⛹🏻‍♂️" }, { "⛹🏻‍♂️" }, { "⛹🏼‍♂️" }, { "⛹🏼‍♂️" }, { "⛹🏽‍♂️" },
		{ "⛹🏽‍♂️" }, { "⛹🏾‍♂️" }, { "⛹🏾‍♂️" }, { "⛹🏿‍♂️" }, { "⛹🏿‍♂️" }, { "🤺" }, { "🤺" }, { "🤺" }, { "🤾" }, { "🤾" },
		{ "🤾🏻" }, { "🤾🏻" }, { "🤾🏼" }, { "🤾🏼" }, { "🤾🏽" }, { "🤾🏽" }, { "🤾🏾" }, { "🤾🏾" }, { "🤾🏿" }, { "🤾🏿" }, { "🤾‍♀️" }, { "🤾🏻‍♀️" },
		{ "🤾🏻‍♀️" }, { "🤾🏼‍♀️" }, { "🤾🏼‍♀️" }, { "🤾🏽‍♀️" }, { "🤾🏽‍♀️" }, { "🤾🏾‍♀️" },
		{ "🤾🏾‍♀️" }, { "🤾🏿‍♀️" }, { "🤾🏿‍♀️" }, { "🤾‍♂️" }, { "🤾🏻‍♂️" }, { "🤾🏻‍♂️" }, { "🤾🏼‍♂️" },
		{ "🤾🏼‍♂️" }, { "🤾🏽‍♂️" }, { "🤾🏽‍♂️" }, { "🤾🏾‍♂️" }, { "🤾🏾‍♂️" }, { "🤾🏿‍♂️" },
		{ "🤾🏿‍♂️" }, { "🏌️" }, { "🏌️" }, { "🏌🏻" }, { "🏌🏻" }, { "🏌🏼" }, { "🏌🏼" }, { "🏌🏽" }, { "🏌🏽" }, { "🏌🏾" }, { "🏌🏾" }, { "🏌🏿" }, { "🏌🏿" },
		{ "🏌️‍♀️" }, { "🏌🏻‍♀️" }, { "🏌🏻‍♀️" }, { "🏌🏼‍♀️" }, { "🏌🏼‍♀️" }, { "🏌🏽‍♀️" },
		{ "🏌🏽‍♀️" }, { "🏌🏾‍♀️" }, { "🏌🏾‍♀️" }, { "🏌🏿‍♀️" }, { "🏌🏿‍♀️" }, { "🏌️‍♂️" },
		{ "🏌🏻‍♂️" }, { "🏌🏻‍♂️" }, { "🏌🏼‍♂️" }, { "🏌🏼‍♂️" }, { "🏌🏽‍♂️" }, { "🏌🏽‍♂️" },
		{ "🏌🏾‍♂️" }, { "🏌🏾‍♂️" }, { "🏌🏿‍♂️" }, { "🏌🏿‍♂️" }, { "🏇" }, { "🏇🏻" }, { "🏇🏼" }, { "🏇🏽" }, { "🏇🏾" }, { "🏇🏿" },
		{ "🧘" }, { "🧘🏻" }, { "🧘🏻" }, { "🧘🏼" }, { "🧘🏼" }, { "🧘🏽" }, { "🧘🏽" }, { "🧘🏾" }, { "🧘🏾" }, { "🧘🏿" }, { "🧘🏿" }, { "🧘‍♀️" },
		{ "🧘🏻‍♀️" }, { "🧘🏻‍♀️" }, { "🧘🏼‍♀️" }, { "🧘🏼‍♀️" }, { "🧘🏽‍♀️" }, { "🧘🏽‍♀️" },
		{ "🧘🏾‍♀️" }, { "🧘🏾‍♀️" }, { "🧘🏿‍♀️" }, { "🧘🏿‍♀️" }, { "🧘‍♂️" }, { "🧘🏻‍♂️" }, { "🧘🏻‍♂️" },
		{ "🧘🏼‍♂️" }, { "🧘🏼‍♂️" }, { "🧘🏽‍♂️" }, { "🧘🏽‍♂️" }, { "🧘🏾‍♂️" }, { "🧘🏾‍♂️" },
		{ "🧘🏿‍♂️" }, { "🧘🏿‍♂️" }, { "🏄" }, { "🏄" }, { "🏄🏻" }, { "🏄🏻" }, { "🏄🏼" }, { "🏄🏼" }, { "🏄🏽" }, { "🏄🏽" }, { "🏄🏾" }, { "🏄🏾" },
		{ "🏄🏿" }, { "🏄🏿" }, { "🏄‍♀️" }, { "🏄🏻‍♀️" }, { "🏄🏻‍♀️" }, { "🏄🏼‍♀️" }, { "🏄🏼‍♀️" }, { "🏄🏽‍♀️" },
		{ "🏄🏽‍♀️" }, { "🏄🏾‍♀️" }, { "🏄🏾‍♀️" }, { "🏄🏿‍♀️" }, { "🏄🏿‍♀️" }, { "🏄‍♂️" }, { "🏄🏻‍♂️" },
		{ "🏄🏻‍♂️" }, { "🏄🏼‍♂️" }, { "🏄🏼‍♂️" }, { "🏄🏽‍♂️" }, { "🏄🏽‍♂️" }, { "🏄🏾‍♂️" },
		{ "🏄🏾‍♂️" }, { "🏄🏿‍♂️" }, { "🏄🏿‍♂️" }, { "🏊" }, { "🏊" }, { "🏊🏻" }, { "🏊🏻" }, { "🏊🏼" }, { "🏊🏼" }, { "🏊🏽" }, { "🏊🏽" },
		{ "🏊🏾" }, { "🏊🏾" }, { "🏊🏿" }, { "🏊🏿" }, { "🏊‍♀️" }, { "🏊🏻‍♀️" }, { "🏊🏻‍♀️" }, { "🏊🏼‍♀️" }, { "🏊🏼‍♀️" },
		{ "🏊🏽‍♀️" }, { "🏊🏽‍♀️" }, { "🏊🏾‍♀️" }, { "🏊🏾‍♀️" }, { "🏊🏿‍♀️" }, { "🏊🏿‍♀️" }, { "🏊‍♂️" },
		{ "🏊🏻‍♂️" }, { "🏊🏻‍♂️" }, { "🏊🏼‍♂️" }, { "🏊🏼‍♂️" }, { "🏊🏽‍♂️" }, { "🏊🏽‍♂️" },
		{ "🏊🏾‍♂️" }, { "🏊🏾‍♂️" }, { "🏊🏿‍♂️" }, { "🏊🏿‍♂️" }, { "🤽" }, { "🤽" }, { "🤽🏻" }, { "🤽🏻" }, { "🤽🏼" }, { "🤽🏼" },
		{ "🤽🏽" }, { "🤽🏽" }, { "🤽🏾" }, { "🤽🏾" }, { "🤽🏿" }, { "🤽🏿" }, { "🤽‍♀️" }, { "🤽🏻‍♀️" }, { "🤽🏻‍♀️" }, { "🤽🏼‍♀️" },
		{ "🤽🏼‍♀️" }, { "🤽🏽‍♀️" }, { "🤽🏽‍♀️" }, { "🤽🏾‍♀️" }, { "🤽🏾‍♀️" }, { "🤽🏿‍♀️" },
		{ "🤽🏿‍♀️" }, { "🤽‍♂️" }, { "🤽🏻‍♂️" }, { "🤽🏻‍♂️" }, { "🤽🏼‍♂️" }, { "🤽🏼‍♂️" }, { "🤽🏽‍♂️" },
		{ "🤽🏽‍♂️" }, { "🤽🏾‍♂️" }, { "🤽🏾‍♂️" }, { "🤽🏿‍♂️" }, { "🤽🏿‍♂️" }, { "🚣" }, { "🚣" }, { "🚣🏻" }, { "🚣🏻" },
		{ "🚣🏼" }, { "🚣🏼" }, { "🚣🏽" }, { "🚣🏽" }, { "🚣🏾" }, { "🚣🏾" }, { "🚣🏿" }, { "🚣🏿" }, { "🚣‍♀️" }, { "🚣🏻‍♀️" }, { "🚣🏻‍♀️" },
		{ "🚣🏼‍♀️" }, { "🚣🏼‍♀️" }, { "🚣🏽‍♀️" }, { "🚣🏽‍♀️" }, { "🚣🏾‍♀️" }, { "🚣🏾‍♀️" },
		{ "🚣🏿‍♀️" }, { "🚣🏿‍♀️" }, { "🚣‍♂️" }, { "🚣🏻‍♂️" }, { "🚣🏻‍♂️" }, { "🚣🏼‍♂️" }, { "🚣🏼‍♂️" },
		{ "🚣🏽‍♂️" }, { "🚣🏽‍♂️" }, { "🚣🏾‍♂️" }, { "🚣🏾‍♂️" }, { "🚣🏿‍♂️" }, { "🚣🏿‍♂️" }, { "🧗" }, { "🧗🏻" },
		{ "🧗🏻" }, { "🧗🏼" }, { "🧗🏼" }, { "🧗🏽" }, { "🧗🏽" }, { "🧗🏾" }, { "🧗🏾" }, { "🧗🏿" }, { "🧗🏿" }, { "🧗‍♀️" }, { "🧗🏻‍♀️" },
		{ "🧗🏻‍♀️" }, { "🧗🏼‍♀️" }, { "🧗🏼‍♀️" }, { "🧗🏽‍♀️" }, { "🧗🏽‍♀️" }, { "🧗🏾‍♀️" },
		{ "🧗🏾‍♀️" }, { "🧗🏿‍♀️" }, { "🧗🏿‍♀️" }, { "🧗‍♂️" }, { "🧗🏻‍♂️" }, { "🧗🏻‍♂️" }, { "🧗🏼‍♂️" },
		{ "🧗🏼‍♂️" }, { "🧗🏽‍♂️" }, { "🧗🏽‍♂️" }, { "🧗🏾‍♂️" }, { "🧗🏾‍♂️" }, { "🧗🏿‍♂️" },
		{ "🧗🏿‍♂️" }, { "🚵" }, { "🚵" }, { "🚵🏻" }, { "🚵🏻" }, { "🚵🏼" }, { "🚵🏼" }, { "🚵🏽" }, { "🚵🏽" }, { "🚵🏾" }, { "🚵🏾" }, { "🚵🏿" }, { "🚵🏿" },
		{ "🚵‍♀️" }, { "🚵🏻‍♀️" }, { "🚵🏻‍♀️" }, { "🚵🏼‍♀️" }, { "🚵🏼‍♀️" }, { "🚵🏽‍♀️" }, { "🚵🏽‍♀️" },
		{ "🚵🏾‍♀️" }, { "🚵🏾‍♀️" }, { "🚵🏿‍♀️" }, { "🚵🏿‍♀️" }, { "🚵‍♂️" }, { "🚵🏻‍♂️" }, { "🚵🏻‍♂️" },
		{ "🚵🏼‍♂️" }, { "🚵🏼‍♂️" }, { "🚵🏽‍♂️" }, { "🚵🏽‍♂️" }, { "🚵🏾‍♂️" }, { "🚵🏾‍♂️" },
		{ "🚵🏿‍♂️" }, { "🚵🏿‍♂️" }, { "🚴" }, { "🚴" }, { "🚴🏻" }, { "🚴🏻" }, { "🚴🏼" }, { "🚴🏼" }, { "🚴🏽" }, { "🚴🏽" }, { "🚴🏾" }, { "🚴🏾" },
		{ "🚴🏿" }, { "🚴🏿" }, { "🚴‍♀️" }, { "🚴🏻‍♀️" }, { "🚴🏻‍♀️" }, { "🚴🏼‍♀️" }, { "🚴🏼‍♀️" }, { "🚴🏽‍♀️" },
		{ "🚴🏽‍♀️" }, { "🚴🏾‍♀️" }, { "🚴🏾‍♀️" }, { "🚴🏿‍♀️" }, { "🚴🏿‍♀️" }, { "🚴‍♂️" }, { "🚴🏻‍♂️" },
		{ "🚴🏻‍♂️" }, { "🚴🏼‍♂️" }, { "🚴🏼‍♂️" }, { "🚴🏽‍♂️" }, { "🚴🏽‍♂️" }, { "🚴🏾‍♂️" },
		{ "🚴🏾‍♂️" }, { "🚴🏿‍♂️" }, { "🚴🏿‍♂️" }, { "🏆" }, { "🥇" }, { "🥇" }, { "🥈" }, { "🥈" }, { "🥉" }, { "🥉" }, { "🏅" }, { "🏅" },
		{ "🎖️" }, { "🏵️" }, { "🎗️" }, { "🎫" }, { "🎟️" }, { "🎟️" }, { "🎪" }, { "🤹" }, { "🤹" }, { "🤹" }, { "🤹🏻" }, { "🤹🏻" }, { "🤹🏻" }, { "🤹🏼" }, { "🤹🏼" }, { "🤹🏼" },
		{ "🤹🏽" }, { "🤹🏽" }, { "🤹🏽" }, { "🤹🏾" }, { "🤹🏾" }, { "🤹🏾" }, { "🤹🏿" }, { "🤹🏿" }, { "🤹🏿" }, { "🤹‍♀️" }, { "🤹🏻‍♀️" },
		{ "🤹🏻‍♀️" }, { "🤹🏼‍♀️" }, { "🤹🏼‍♀️" }, { "🤹🏽‍♀️" }, { "🤹🏽‍♀️" }, { "🤹🏾‍♀️" },
		{ "🤹🏾‍♀️" }, { "🤹🏿‍♀️" }, { "🤹🏿‍♀️" }, { "🤹‍♂️" }, { "🤹🏻‍♂️" }, { "🤹🏻‍♂️" }, { "🤹🏼‍♂️" },
		{ "🤹🏼‍♂️" }, { "🤹🏽‍♂️" }, { "🤹🏽‍♂️" }, { "🤹🏾‍♂️" }, { "🤹🏾‍♂️" }, { "🤹🏿‍♂️" },
		{ "🤹🏿‍♂️" }, { "🎭" }, { "🩰" }, { "🎨" }, { "🎬" }, { "🎬" }, { "🎤" }, { "🎧" }, { "🎧" }, { "🎼" }, { "🎹" }, { "🪇" }, { "🥁" }, { "🥁" }, { "🪘" },
		{ "🎷" }, { "🎺" }, { "🪗" }, { "🎸" }, { "🪕" }, { "🎻" }, { "🪈" }, { "🎲" }, { "♟️" }, { "🎯" }, { "🎯" }, { "🎳" }, { "🎮" }, { "🎰" }, { "🧩" }, { "🧩" }, { "🏳️" },
		{ "🏴" }, { "🏴‍☠️" }, { "🏁" }, { "🚩" }, { "🏳️‍🌈" }, { "🏳️‍🌈" }, { "🏳️‍⚧️" }, { "🇺🇳" }, { "🇦🇫" }, { "🇦🇽" }, { "🇦🇱" }, { "🇩🇿" },
		{ "🇦🇸" }, { "🇦🇩" }, { "🇦🇴" }, { "🇦🇮" }, { "🇦🇶" }, { "🇦🇬" }, { "🇦🇷" }, { "🇦🇲" }, { "🇦🇼" }, { "🇦🇺" }, { "🇦🇹" }, { "🇦🇿" }, { "🇧🇸" }, { "🇧🇭" }, { "🇧🇩" }, { "🇧🇧" }, { "🇧🇾" },
		{ "🇧🇪" }, { "🇧🇿" }, { "🇧🇯" }, { "🇧🇲" }, { "🇧🇹" }, { "🇧🇴" }, { "🇧🇦" }, { "🇧🇼" }, { "🇧🇷" }, { "🇮🇴" }, { "🇻🇬" }, { "🇧🇳" }, { "🇧🇬" }, { "🇧🇫" }, { "🇧🇮" }, { "🇰🇭" }, { "🇨🇲" },
		{ "🇨🇦" }, { "🇮🇨" }, { "🇨🇻" }, { "🇧🇶" }, { "🇰🇾" }, { "🇨🇫" }, { "🇹🇩" }, { "🇨🇱" }, { "🇨🇳" }, { "🇨🇽" }, { "🇨🇨" }, { "🇨🇴" }, { "🇰🇲" }, { "🇨🇬" }, { "🇨🇩" }, { "🇨🇰" }, { "🇨🇷" },
		{ "🇨🇮" }, { "🇭🇷" }, { "🇨🇺" }, { "🇨🇼" }, { "🇨🇾" }, { "🇨🇿" }, { "🇩🇰" }, { "🇩🇯" }, { "🇩🇲" }, { "🇩🇴" }, { "🇪🇨" }, { "🇪🇬" }, { "🇸🇻" }, { "🇬🇶" }, { "🇪🇷" }, { "🇪🇪" }, { "🇪🇹" },
		{ "🇪🇺" }, { "🇫🇰" }, { "🇫🇴" }, { "🇫🇯" }, { "🇫🇮" }, { "🇫🇷" }, { "🇬🇫" }, { "🇵🇫" }, { "🇹🇫" }, { "🇬🇦" }, { "🇬🇲" }, { "🇬🇪" }, { "🇩🇪" }, { "🇬🇭" }, { "🇬🇮" }, { "🇬🇷" }, { "🇬🇱" },
		{ "🇬🇩" }, { "🇬🇵" }, { "🇬🇺" }, { "🇬🇹" }, { "🇬🇬" }, { "🇬🇳" }, { "🇬🇼" }, { "🇬🇾" }, { "🇭🇹" }, { "🇭🇳" }, { "🇭🇰" }, { "🇭🇺" }, { "🇮🇸" }, { "🇮🇳" }, { "🇮🇩" }, { "🇮🇷" }, { "🇮🇶" },
		{ "🇮🇪" }, { "🇮🇲" }, { "🇮🇱" }, { "🇮🇹" }, { "🇯🇲" }, { "🇯🇵" }, { "🎌" }, { "🇯🇪" }, { "🇯🇴" }, { "🇰🇿" }, { "🇰🇪" }, { "🇰🇮" }, { "🇽🇰" }, { "🇰🇼" }, { "🇰🇬" }, { "🇱🇦" }, { "🇱🇻" },
		{ "🇱🇧" }, { "🇱🇸" }, { "🇱🇷" }, { "🇱🇾" }, { "🇱🇮" }, { "🇱🇹" }, { "🇱🇺" }, { "🇲🇴" }, { "🇲🇰" }, { "🇲🇬" }, { "🇲🇼" }, { "🇲🇾" }, { "🇲🇻" }, { "🇲🇱" }, { "🇲🇹" }, { "🇲🇭" }, { "🇲🇶" },
		{ "🇲🇷" }, { "🇲🇺" }, { "🇾🇹" }, { "🇲🇽" }, { "🇫🇲" }, { "🇲🇩" }, { "🇲🇨" }, { "🇲🇳" }, { "🇲🇪" }, { "🇲🇸" }, { "🇲🇦" }, { "🇲🇿" }, { "🇲🇲" }, { "🇳🇦" }, { "🇳🇷" }, { "🇳🇵" }, { "🇳🇱" },
		{ "🇳🇨" }, { "🇳🇿" }, { "🇳🇮" }, { "🇳🇪" }, { "🇳🇬" }, { "🇳🇺" }, { "🇳🇫" }, { "🇰🇵" }, { "🇲🇵" }, { "🇳🇴" }, { "🇴🇲" }, { "🇵🇰" }, { "🇵🇼" }, { "🇵🇸" }, { "🇵🇦" }, { "🇵🇬" }, { "🇵🇾" },
		{ "🇵🇪" }, { "🇵🇭" }, { "🇵🇳" }, { "🇵🇱" }, { "🇵🇹" }, { "🇵🇷" }, { "🇶🇦" }, { "🇷🇪" }, { "🇷🇴" }, { "🇷🇺" }, { "🇷🇼" }, { "🇼🇸" }, { "🇸🇲" }, { "🇸🇹" }, { "🇸🇦" }, { "🇸🇳" }, { "🇷🇸" },
		{ "🇸🇨" }, { "🇸🇱" }, { "🇸🇬" }, { "🇸🇽" }, { "🇸🇰" }, { "🇸🇮" }, { "🇬🇸" }, { "🇸🇧" }, { "🇸🇴" }, { "🇿🇦" }, { "🇰🇷" }, { "🇸🇸" }, { "🇪🇸" }, { "🇱🇰" }, { "🇧🇱" }, { "🇸🇭" }, { "🇰🇳" },
		{ "🇱🇨" }, { "🇵🇲" }, { "🇻🇨" }, { "🇸🇩" }, { "🇸🇷" }, { "🇸🇿" }, { "🇸🇪" }, { "🇨🇭" }, { "🇸🇾" }, { "🇹🇼" }, { "🇹🇯" }, { "🇹🇿" }, { "🇹🇭" }, { "🇹🇱" }, { "🇹🇬" }, { "🇹🇰" }, { "🇹🇴" },
		{ "🇹🇹" }, { "🇹🇳" }, { "🇹🇷" }, { "🇹🇲" }, { "🇹🇨" }, { "🇻🇮" }, { "🇹🇻" }, { "🇺🇬" }, { "🇺🇦" }, { "🇦🇪" }, { "🇬🇧" }, { "🏴󠁧󠁢󠁥󠁮󠁧󠁿" },
		{ "🏴󠁧󠁢󠁳󠁣󠁴󠁿" }, { "🏴󠁧󠁢󠁷󠁬󠁳󠁿" }, { "🇺🇸" }, { "🇺🇾" }, { "🇺🇿" }, { "🇻🇺" }, { "🇻🇦" }, { "🇻🇪" }, { "🇻🇳" }, { "🇼🇫" }, { "🇪🇭" }, { "🇾🇪" },
		{ "🇿🇲" }, { "🇿🇼" }, { "🇦🇨" }, { "🇧🇻" }, { "🇨🇵" }, { "🇪🇦" }, { "🇩🇬" }, { "🇭🇲" }, { "🇲🇫" }, { "🇸🇯" }, { "🇹🇦" }, { "🇺🇲" }, { "🍏" }, { "🍎" }, { "🍎" }, { "🍐" }, { "🍊" },
		{ "🍋" }, { "🍌" }, { "🍉" }, { "🍇" }, { "🍓" }, { "🫐" }, { "🍈" }, { "🍒" }, { "🍑" }, { "🥭" }, { "🍍" }, { "🥥" }, { "🥝" }, { "🥝" }, { "🥝" }, { "🍅" }, { "🍆" },
		{ "🥑" }, { "🫛" }, { "🥦" }, { "🥬" }, { "🥒" }, { "🌶️" }, { "🫑" }, { "🌽" }, { "🌽" }, { "🥕" }, { "🫒" }, { "🧄" }, { "🧅" }, { "🥔" }, { "🍠" }, { "🫚" }, { "🥐" },
		{ "🥯" }, { "🍞" }, { "🥖" }, { "🥖" }, { "🥨" }, { "🧀" }, { "🧀" }, { "🥚" }, { "🍳" }, { "🧈" }, { "🥞" }, { "🧇" }, { "🥓" }, { "🥩" }, { "🍗" }, { "🍖" }, { "🦴" },
		{ "🌭" }, { "🌭" }, { "🍔" }, { "🍟" }, { "🍟" }, { "🍕" }, { "🫓" }, { "🥪" }, { "🥙" }, { "🥙" }, { "🧆" }, { "🌮" }, { "🌯" }, { "🫔" }, { "🥗" }, { "🥗" }, { "🥘" },
		{ "🥘" }, { "🫕" }, { "🥫" }, { "🫙" }, { "🍝" }, { "🍜" }, { "🍜" }, { "🍲" }, { "🍲" }, { "🍛" }, { "🍛" }, { "🍣" }, { "🍱" }, { "🍱" }, { "🥟" }, { "🦪" }, { "🍤" },
		{ "🍙" }, { "🍚" }, { "🍚" }, { "🍘" }, { "🍥" }, { "🥠" }, { "🥮" }, { "🍢" }, { "🍡" }, { "🍧" }, { "🍨" }, { "🍦" }, { "🥧" }, { "🧁" }, { "🍰" }, { "🍰" }, { "🎂" },
		{ "🎂" }, { "🍮" }, { "🍮" }, { "🍮" }, { "🍭" }, { "🍬" }, { "🍫" }, { "🍿" }, { "🍩" }, { "🍪" }, { "🌰" }, { "🥜" }, { "🥜" }, { "🫘" }, { "🍯" }, { "🥛" }, { "🥛" },
		{ "🫗" }, { "🍼" }, { "🫖" }, { "☕" }, { "☕" }, { "🍵" }, { "🧉" }, { "🧃" }, { "🥤" }, { "🧋" }, { "🍶" }, { "🍺" }, { "🍺" }, { "🍻" }, { "🥂" }, { "🥂" }, { "🍷" },
		{ "🥃" }, { "🥃" }, { "🍸" }, { "🍹" }, { "🍾" }, { "🍾" }, { "🧊" }, { "🥄" }, { "🍴" }, { "🍽️" }, { "🍽️" }, { "🥣" }, { "🥡" }, { "🥢" }, { "🧂" }, { "🐶" }, { "🐶" },
		{ "🐱" }, { "🐱" }, { "🐭" }, { "🐭" }, { "🐹" }, { "🐰" }, { "🐰" }, { "🦊" }, { "🦊" }, { "🐻" }, { "🐼" }, { "🐼" }, { "🐻‍❄️" }, { "🐨" }, { "🐯" }, { "🐯" },
		{ "🦁" }, { "🦁" }, { "🐮" }, { "🐮" }, { "🐷" }, { "🐷" }, { "🐽" }, { "🐸" }, { "🐵" }, { "🙈" }, { "🙉" }, { "🙊" }, { "🐒" }, { "🐔" }, { "🐧" }, { "🐦" }, { "🐤" },
		{ "🐣" }, { "🐥" }, { "🪿" }, { "🦆" }, { "🐦‍⬛" }, { "🦅" }, { "🦉" }, { "🦇" }, { "🐺" }, { "🐗" }, { "🐴" }, { "🐴" }, { "🦄" }, { "🦄" }, { "🫎" }, { "🐝" },
		{ "🐝" }, { "🪱" }, { "🐛" }, { "🦋" }, { "🐌" }, { "🐞" }, { "🐜" }, { "🪰" }, { "🪲" }, { "🪳" }, { "🦟" }, { "🦗" }, { "🕷️" }, { "🕸️" }, { "🦂" }, { "🐢" }, { "🐍" },
		{ "🦎" }, { "🦖" }, { "🦕" }, { "🐙" }, { "🦑" }, { "🪼" }, { "🦐" }, { "🦞" }, { "🦀" }, { "🐡" }, { "🐠" }, { "🐟" }, { "🐬" }, { "🐳" }, { "🐋" }, { "🦈" }, { "🦭" },
		{ "🐊" }, { "🐅" }, { "🐆" }, { "🦓" }, { "🦍" }, { "🦧" }, { "🦣" }, { "🐘" }, { "🦛" }, { "🦏" }, { "🦏" }, { "🐪" }, { "🐫" }, { "🦒" }, { "🦘" }, { "🦬" }, { "🐃" },
		{ "🐂" }, { "🐄" }, { "🫏" }, { "🐎" }, { "🐖" }, { "🐏" }, { "🐑" }, { "🐑" }, { "🦙" }, { "🐐" }, { "🦌" }, { "🐕" }, { "🐩" }, { "🦮" }, { "🐕‍🦺" }, { "🐈" },
		{ "🐈‍⬛" }, { "🪶" }, { "🪽" }, { "🐓" }, { "🦃" }, { "🦤" }, { "🦚" }, { "🦜" }, { "🦢" }, { "🦩" }, { "🕊️" }, { "🕊️" }, { "🐇" }, { "🦝" }, { "🦨" }, { "🦡" },
		{ "🦫" }, { "🦦" }, { "🦥" }, { "🐁" }, { "🐀" }, { "🐿️" }, { "🦔" }, { "🐾" }, { "🐾" }, { "🐉" }, { "🐲" }, { "🌵" }, { "🎄" }, { "🌲" }, { "🌳" }, { "🌴" }, { "🪵" },
		{ "🌱" }, { "🌿" }, { "☘️" }, { "🍀" }, { "🎍" }, { "🪴" }, { "🎋" }, { "🍃" }, { "🍂" }, { "🍁" }, { "🪺" }, { "🪹" }, { "🍄" }, { "🐚" }, { "🐚" }, { "🪸" }, { "🪨" },
		{ "🌾" }, { "🌾" }, { "💐" }, { "🌷" }, { "🌹" }, { "🥀" }, { "🥀" }, { "🪻" }, { "🪷" }, { "🌺" }, { "🌸" }, { "🌼" }, { "🌻" }, { "🌞" }, { "🌝" }, { "🌛" }, { "🌜" },
		{ "🌚" }, { "🌚" }, { "🌕" }, { "🌖" }, { "🌗" }, { "🌘" }, { "🌑" }, { "🌒" }, { "🌓" }, { "🌔" }, { "🌙" }, { "🌎" }, { "🌍" }, { "🌏" }, { "🪐" }, { "💫" }, { "⭐" },
		{ "🌟" }, { "🌟" }, { "✨" }, { "⚡" }, { "⚡" }, { "☄️" }, { "💥" }, { "💥" }, { "🔥" }, { "🔥" }, { "🌪️" }, { "🌪️" }, { "🌪️" }, { "🌈" }, { "☀️" }, { "☀️" }, { "🌤️" },
		{ "🌤️" }, { "⛅" }, { "🌥️" }, { "🌥️" }, { "☁️" }, { "🌦️" }, { "🌦️" }, { "🌧️" }, { "🌧️" }, { "⛈️" }, { "⛈️" }, { "🌩️" }, { "🌩️" }, { "🌨️" }, { "🌨️" }, { "❄️" }, { "☃️" },
		{ "⛄" }, { "🌬️" }, { "🌬️" }, { "💨" }, { "💨" }, { "💧" }, { "💦" }, { "🫧" }, { "☔" }, { "☂️" }, { "🌊" }, { "🌊" }, { "🌫️" }, { "⌚" }, { "📱" }, { "📱" }, { "📲" },
		{ "💻" }, { "⌨️" }, { "🖥️" }, { "🖥️" }, { "🖨️" }, { "🖱️" }, { "🖱️" }, { "🖲️" }, { "🕹️" }, { "🗜️" }, { "🗜️" }, { "💽" }, { "💽" }, { "💾" }, { "💿" }, { "💿" }, { "📀" },
		{ "📼" }, { "📼" }, { "📷" }, { "📸" }, { "📹" }, { "🎥" }, { "📽️" }, { "📽️" }, { "🎞️" }, { "📞" }, { "☎️" }, { "📟" }, { "📠" }, { "📠" }, { "📺" }, { "📺" }, { "📻" },
		{ "🎙️" }, { "🎙️" }, { "🎚️" }, { "🎛️" }, { "🧭" }, { "⏱️" }, { "⏲️" }, { "⏲️" }, { "⏰" }, { "🕰️" }, { "🕰️" }, { "⌛" }, { "⏳" }, { "📡" }, { "🔋" }, { "🪫" }, { "🔌" },
		{ "💡" }, { "💡" }, { "🔦" }, { "🕯️" }, { "🪔" }, { "🧯" }, { "🛢️" }, { "🛢️" }, { "💸" }, { "💵" }, { "💴" }, { "💴" }, { "💶" }, { "💶" }, { "💷" }, { "🪙" }, { "💰" },
		{ "💰" }, { "💳" }, { "🪪" }, { "💎" }, { "💎" }, { "⚖️" }, { "⚖️" }, { "🪜" }, { "🧰" }, { "🪛" }, { "🔧" }, { "🔨" }, { "⚒️" }, { "⚒️" }, { "🛠️" }, { "🛠️" }, { "⛏️" }, { "🪚" },
		{ "🔩" }, { "⚙️" }, { "🪤" }, { "🧱" }, { "🧱" }, { "⛓️" }, { "🧲" }, { "🔫" }, { "🔫" }, { "💣" }, { "🧨" }, { "🪓" }, { "🔪" }, { "🔪" }, { "🗡️" }, { "🗡️" }, { "⚔️" },
		{ "🛡️" }, { "🚬" }, { "🚬" }, { "⚰️" }, { "🪦" }, { "⚱️" }, { "⚱️" }, { "🏺" }, { "🔮" }, { "📿" }, { "🧿" }, { "🪬" }, { "💈" }, { "💈" }, { "⚗️" }, { "🔭" }, { "🔬" },
		{ "🕳️" }, { "🩻" }, { "🩹" }, { "🩺" }, { "💊" }, { "💉" }, { "🩸" }, { "🧬" }, { "🦠" }, { "🧫" }, { "🧪" }, { "🌡️" }, { "🧹" }, { "🪠" }, { "🧺" }, { "🧻" }, { "🚽" },
		{ "🚰" }, { "🚿" }, { "🛁" }, { "🛀" }, { "🛀🏻" }, { "🛀🏼" }, { "🛀🏽" }, { "🛀🏾" }, { "🛀🏿" }, { "🧼" }, { "🪥" }, { "🪒" }, { "🪮" }, { "🧽" }, { "🪣" }, { "🧴" },
		{ "🧴" }, { "🛎️" }, { "🛎️" }, { "🔑" }, { "🗝️" }, { "🗝️" }, { "🚪" }, { "🪑" }, { "🛋️" }, { "🛋️" }, { "🛏️" }, { "🛌" }, { "🛌" }, { "🛌🏻" }, { "🛌🏻" }, { "🛌🏼" }, { "🛌🏼" },
		{ "🛌🏽" }, { "🛌🏽" }, { "🛌🏾" }, { "🛌🏾" }, { "🛌🏿" }, { "🛌🏿" }, { "🧸" }, { "🪆" }, { "🖼️" }, { "🖼️" }, { "🪞" }, { "🪟" }, { "🛍️" }, { "🛒" }, { "🛒" }, { "🎁" },
		{ "🎁" }, { "🎈" }, { "🎏" }, { "🎏" }, { "🎀" }, { "🪄" }, { "🪅" }, { "🎊" }, { "🎉" }, { "🎉" }, { "🎎" }, { "🪭" }, { "🏮" }, { "🎐" }, { "🪩" }, { "🧧" }, { "✉️" },
		{ "📩" }, { "📨" }, { "📧" }, { "📧" }, { "💌" }, { "📥" }, { "📤" }, { "📦" }, { "🏷️" }, { "🪧" }, { "📪" }, { "📫" }, { "📬" }, { "📭" }, { "📮" }, { "📯" }, { "📜" },
		{ "📃" }, { "📄" }, { "📑" }, { "🧾" }, { "📊" }, { "📈" }, { "📉" }, { "🗒️" }, { "🗒️" }, { "🗓️" }, { "🗓️" }, { "📆" }, { "📅" }, { "🗑️" }, { "📇" }, { "🗃️" }, { "🗃️" },
		{ "🗳️" }, { "🗳️" }, { "🗄️" }, { "📋" }, { "📁" }, { "📂" }, { "🗂️" }, { "🗂️" }, { "🗞️" }, { "🗞️" }, { "📰" }, { "📓" }, { "📔" }, { "📒" }, { "📕" }, { "📗" }, { "📘" },
		{ "📙" }, { "📚" }, { "📖" }, { "📖" }, { "🔖" }, { "🧷" }, { "🔗" }, { "📎" }, { "🖇️" }, { "🖇️" }, { "📐" }, { "📏" }, { "🧮" }, { "📌" }, { "📍" }, { "✂️" }, { "🖊️" },
		{ "🖊️" }, { "🖊️" }, { "🖋️" }, { "🖋️" }, { "🖋️" }, { "✒️" }, { "🖌️" }, { "🖌️" }, { "🖍️" }, { "🖍️" }, { "📝" }, { "📝" }, { "✏️" }, { "🔍" }, { "🔎" }, { "🔏" }, { "🔐" },
		{ "🔒" }, { "🔒" }, { "🔓" }, { "🔓" }, { "😀" }, { "😀" }, { "😃" }, { "😄" }, { "😁" }, { "😆" }, { "😆" }, { "🥹" }, { "😅" }, { "😂" }, { "🤣" }, { "🤣" }, { "🥲" },
		{ "☺️" }, { "☺️" }, { "😊" }, { "😇" }, { "🙂" }, { "🙂" }, { "🙃" }, { "🙃" }, { "😉" }, { "😉" }, { "😌" }, { "😌" }, { "😍" }, { "🥰" }, { "😘" }, { "😗" }, { "😗" },
		{ "😙" }, { "😚" }, { "😋" }, { "😛" }, { "😝" }, { "😜" }, { "🤪" }, { "🤨" }, { "🧐" }, { "🤓" }, { "🤓" }, { "😎" }, { "🥸" }, { "🤩" }, { "🥳" }, { "😏" }, { "😏" },
		{ "😒" }, { "😒" }, { "😞" }, { "😔" }, { "😔" }, { "😟" }, { "😟" }, { "😕" }, { "😕" }, { "🙁" }, { "🙁" }, { "☹️" }, { "☹️" }, { "☹️" }, { "😣" }, { "😖" }, { "😫" },
		{ "😩" }, { "😩" }, { "🥺" }, { "😢" }, { "😢" }, { "😭" }, { "😤" }, { "😠" }, { "😠" }, { "😡" }, { "😡" }, { "🤬" }, { "🤯" }, { "😳" }, { "😳" }, { "🥵" }, { "🥶" },
		{ "😶‍🌫️" }, { "😱" }, { "😨" }, { "😨" }, { "😰" }, { "😥" }, { "😓" }, { "🤗" }, { "🤗" }, { "🤔" }, { "🤔" }, { "🫣" }, { "🤭" }, { "🫢" }, { "🫡" }, { "🤫" },
		{ "🫠" }, { "🤥" }, { "🤥" }, { "😶" }, { "🫥" }, { "😐" }, { "🫤" }, { "😑" }, { "🫨" }, { "😬" }, { "🙄" }, { "🙄" }, { "😯" }, { "😯" }, { "😦" }, { "😧" }, { "😮" },
		{ "😲" }, { "🥱" }, { "😴" }, { "😴" }, { "🤤" }, { "🤤" }, { "😪" }, { "😪" }, { "😮‍💨" }, { "😵" }, { "😵‍💫" }, { "🤐" }, { "🤐" }, { "🥴" }, { "🤢" },
		{ "🤢" }, { "🤮" }, { "🤧" }, { "🤧" }, { "😷" }, { "🤒" }, { "🤒" }, { "🤕" }, { "🤕" }, { "🤑" }, { "🤑" }, { "🤠" }, { "🤠" }, { "😈" }, { "👿" }, { "👹" }, { "👹" },
		{ "👺" }, { "👺" }, { "🤡" }, { "🤡" }, { "💩" }, { "💩" }, { "💩" }, { "💩" }, { "💩" }, { "👻" }, { "💀" }, { "💀" }, { "☠️" }, { "☠️" }, { "👽" }, { "👾" }, { "👾" },
		{ "🤖" }, { "🤖" }, { "🎃" }, { "😺" }, { "😺" }, { "😸" }, { "😹" }, { "😻" }, { "😼" }, { "😽" }, { "🙀" }, { "🙀" }, { "😿" }, { "😿" }, { "😾" }, { "🫶" }, { "🫶🏻" },
		{ "🫶🏻" }, { "🫶🏼" }, { "🫶🏼" }, { "🫶🏽" }, { "🫶🏽" }, { "🫶🏾" }, { "🫶🏾" }, { "🫶🏿" }, { "🫶🏿" }, { "🤲" }, { "🤲🏻" }, { "🤲🏻" }, { "🤲🏼" }, { "🤲🏼" },
		{ "🤲🏽" }, { "🤲🏽" }, { "🤲🏾" }, { "🤲🏾" }, { "🤲🏿" }, { "🤲🏿" }, { "👐" }, { "👐🏻" }, { "👐🏼" }, { "👐🏽" }, { "👐🏾" }, { "👐🏿" }, { "🙌" }, { "🙌" },
		{ "🙌🏻" }, { "🙌🏼" }, { "🙌🏽" }, { "🙌🏾" }, { "🙌🏿" }, { "👏" }, { "👏🏻" }, { "👏🏼" }, { "👏🏽" }, { "👏🏾" }, { "👏🏿" }, { "🤝" }, { "🤝" }, { "🤝🏻" },
		{ "🤝🏻" }, { "🫱🏻‍🫲🏼" }, { "🫱🏻‍🫲🏼" }, { "🫱🏻‍🫲🏽" }, { "🫱🏻‍🫲🏽" }, { "🫱🏻‍🫲🏾" },
		{ "🫱🏻‍🫲🏾" }, { "🫱🏻‍🫲🏿" }, { "🫱🏻‍🫲🏿" }, { "🫱🏼‍🫲🏻" }, { "🫱🏼‍🫲🏻" }, { "🤝🏼" }, { "🤝🏼" },
		{ "🫱🏼‍🫲🏽" }, { "🫱🏼‍🫲🏽" }, { "🫱🏼‍🫲🏾" }, { "🫱🏼‍🫲🏾" }, { "🫱🏼‍🫲🏿" }, { "🫱🏼‍🫲🏿" },
		{ "🫱🏽‍🫲🏻" }, { "🫱🏽‍🫲🏻" }, { "🫱🏽‍🫲🏼" }, { "🫱🏽‍🫲🏼" }, { "🤝🏽" }, { "🤝🏽" }, { "🫱🏽‍🫲🏾" },
		{ "🫱🏽‍🫲🏾" }, { "🫱🏽‍🫲🏿" }, { "🫱🏽‍🫲🏿" }, { "🫱🏾‍🫲🏻" }, { "🫱🏾‍🫲🏻" }, { "🫱🏾‍🫲🏼" },
		{ "🫱🏾‍🫲🏼" }, { "🫱🏾‍🫲🏽" }, { "🫱🏾‍🫲🏽" }, { "🤝🏾" }, { "🤝🏾" }, { "🫱🏾‍🫲🏿" }, { "🫱🏾‍🫲🏿" },
		{ "🫱🏿‍🫲🏻" }, { "🫱🏿‍🫲🏻" }, { "🫱🏿‍🫲🏼" }, { "🫱🏿‍🫲🏼" }, { "🫱🏿‍🫲🏽" }, { "🫱🏿‍🫲🏽" },
		{ "🫱🏿‍🫲🏾" }, { "🫱🏿‍🫲🏾" }, { "🤝🏿" }, { "🤝🏿" }, { "👍" }, { "👍" }, { "👍" }, { "👍" }, { "👍🏻" }, { "👍🏻" }, { "👍🏻" }, { "👍🏼" },
		{ "👍🏼" }, { "👍🏼" }, { "👍🏽" }, { "👍🏽" }, { "👍🏽" }, { "👍🏾" }, { "👍🏾" }, { "👍🏾" }, { "👍🏿" }, { "👍🏿" }, { "👍🏿" }, { "👎" }, { "👎" }, { "👎" }, { "👎" },
		{ "👎🏻" }, { "👎🏻" }, { "👎🏻" }, { "👎🏼" }, { "👎🏼" }, { "👎🏼" }, { "👎🏽" }, { "👎🏽" }, { "👎🏽" }, { "👎🏾" }, { "👎🏾" }, { "👎🏾" }, { "👎🏿" }, { "👎🏿" },
		{ "👎🏿" }, { "👊" }, { "👊" }, { "👊🏻" }, { "👊🏼" }, { "👊🏽" }, { "👊🏾" }, { "👊🏿" }, { "✊" }, { "✊" }, { "✊🏻" }, { "✊🏼" }, { "✊🏽" }, { "✊🏾" }, { "✊🏿" },
		{ "🤛" }, { "🤛" }, { "🤛🏻" }, { "🤛🏻" }, { "🤛🏼" }, { "🤛🏼" }, { "🤛🏽" }, { "🤛🏽" }, { "🤛🏾" }, { "🤛🏾" }, { "🤛🏿" }, { "🤛🏿" }, { "🤜" }, { "🤜" }, { "🤜🏻" },
		{ "🤜🏻" }, { "🤜🏼" }, { "🤜🏼" }, { "🤜🏽" }, { "🤜🏽" }, { "🤜🏾" }, { "🤜🏾" }, { "🤜🏿" }, { "🤜🏿" }, { "🫷" }, { "🫷🏻" }, { "🫷🏻" }, { "🫷🏼" }, { "🫷🏼" },
		{ "🫷🏽" }, { "🫷🏽" }, { "🫷🏾" }, { "🫷🏾" }, { "🫷🏿" }, { "🫷🏿" }, { "🫸" }, { "🫸🏻" }, { "🫸🏻" }, { "🫸🏼" }, { "🫸🏼" }, { "🫸🏽" }, { "🫸🏽" }, { "🫸🏾" },
		{ "🫸🏾" }, { "🫸🏿" }, { "🫸🏿" }, { "🤞" }, { "🤞" }, { "🤞🏻" }, { "🤞🏻" }, { "🤞🏼" }, { "🤞🏼" }, { "🤞🏽" }, { "🤞🏽" }, { "🤞🏾" }, { "🤞🏾" }, { "🤞🏿" },
		{ "🤞🏿" }, { "✌️" }, { "✌️" }, { "✌🏻" }, { "✌🏼" }, { "✌🏽" }, { "✌🏾" }, { "✌🏿" }, { "🫰" }, { "🫰🏻" }, { "🫰🏻" }, { "🫰🏼" }, { "🫰🏼" }, { "🫰🏽" }, { "🫰🏽" },
		{ "🫰🏾" }, { "🫰🏾" }, { "🫰🏿" }, { "🫰🏿" }, { "🤟" }, { "🤟🏻" }, { "🤟🏻" }, { "🤟🏼" }, { "🤟🏼" }, { "🤟🏽" }, { "🤟🏽" }, { "🤟🏾" }, { "🤟🏾" }, { "🤟🏿" },
		{ "🤟🏿" }, { "🤘" }, { "🤘" }, { "🤘🏻" }, { "🤘🏻" }, { "🤘🏼" }, { "🤘🏼" }, { "🤘🏽" }, { "🤘🏽" }, { "🤘🏾" }, { "🤘🏾" }, { "🤘🏿" }, { "🤘🏿" }, { "👌" },
		{ "👌🏻" }, { "👌🏼" }, { "👌🏽" }, { "👌🏾" }, { "👌🏿" }, { "🤌" }, { "🤌🏼" }, { "🤌🏼" }, { "🤌🏻" }, { "🤌🏻" }, { "🤌🏽" }, { "🤌🏽" }, { "🤌🏾" }, { "🤌🏾" },
		{ "🤌🏿" }, { "🤌🏿" }, { "🤏" }, { "🤏🏻" }, { "🤏🏻" }, { "🤏🏼" }, { "🤏🏼" }, { "🤏🏽" }, { "🤏🏽" }, { "🤏🏾" }, { "🤏🏾" }, { "🤏🏿" }, { "🤏🏿" }, { "🫳" },
		{ "🫳🏻" }, { "🫳🏻" }, { "🫳🏼" }, { "🫳🏼" }, { "🫳🏽" }, { "🫳🏽" }, { "🫳🏾" }, { "🫳🏾" }, { "🫳🏿" }, { "🫳🏿" }, { "🫴" }, { "🫴🏻" }, { "🫴🏻" }, { "🫴🏼" },
		{ "🫴🏼" }, { "🫴🏽" }, { "🫴🏽" }, { "🫴🏾" }, { "🫴🏾" }, { "🫴🏿" }, { "🫴🏿" }, { "👈" }, { "👈🏻" }, { "👈🏼" }, { "👈🏽" }, { "👈🏾" }, { "👈🏿" }, { "👉" },
		{ "👉🏻" }, { "👉🏼" }, { "👉🏽" }, { "👉🏾" }, { "👉🏿" }, { "👆" }, { "👆🏻" }, { "👆🏼" }, { "👆🏽" }, { "👆🏾" }, { "👆🏿" }, { "👇" }, { "👇🏻" }, { "👇🏼" },
		{ "👇🏽" }, { "👇🏾" }, { "👇🏿" }, { "☝️" }, { "☝🏻" }, { "☝🏼" }, { "☝🏽" }, { "☝🏾" }, { "☝🏿" }, { "✋" }, { "✋🏻" }, { "✋🏼" }, { "✋🏽" }, { "✋🏾" }, { "✋🏿" },
		{ "🤚" }, { "🤚" }, { "🤚🏻" }, { "🤚🏻" }, { "🤚🏼" }, { "🤚🏼" }, { "🤚🏽" }, { "🤚🏽" }, { "🤚🏾" }, { "🤚🏾" }, { "🤚🏿" }, { "🤚🏿" }, { "🖐️" }, { "🖐️" }, { "🖐🏻" },
		{ "🖐🏻" }, { "🖐🏼" }, { "🖐🏼" }, { "🖐🏽" }, { "🖐🏽" }, { "🖐🏾" }, { "🖐🏾" }, { "🖐🏿" }, { "🖐🏿" }, { "🖖" }, { "🖖" }, { "🖖" }, { "🖖🏻" }, { "🖖🏻" },
		{ "🖖🏼" }, { "🖖🏼" }, { "🖖🏽" }, { "🖖🏽" }, { "🖖🏾" }, { "🖖🏾" }, { "🖖🏿" }, { "🖖🏿" }, { "👋" }, { "👋" }, { "👋🏻" }, { "👋🏼" }, { "👋🏽" }, { "👋🏾" },
		{ "👋🏿" }, { "🤙" }, { "🤙" }, { "🤙🏻" }, { "🤙🏻" }, { "🤙🏼" }, { "🤙🏼" }, { "🤙🏽" }, { "🤙🏽" }, { "🤙🏾" }, { "🤙🏾" }, { "🤙🏿" }, { "🤙🏿" }, { "🫲" },
		{ "🫲🏻" }, { "🫲🏻" }, { "🫲🏼" }, { "🫲🏼" }, { "🫲🏽" }, { "🫲🏽" }, { "🫲🏾" }, { "🫲🏾" }, { "🫲🏿" }, { "🫲🏿" }, { "🫱" }, { "🫱🏻" }, { "🫱🏻" }, { "🫱🏼" },
		{ "🫱🏼" }, { "🫱🏽" }, { "🫱🏽" }, { "🫱🏾" }, { "🫱🏾" }, { "🫱🏿" }, { "🫱🏿" }, { "💪" }, { "💪" }, { "💪🏻" }, { "💪🏼" }, { "💪🏽" }, { "💪🏾" }, { "💪🏿" },
		{ "🦾" }, { "🖕" }, { "🖕" }, { "🖕🏻" }, { "🖕🏻" }, { "🖕🏼" }, { "🖕🏼" }, { "🖕🏽" }, { "🖕🏽" }, { "🖕🏾" }, { "🖕🏾" }, { "🖕🏿" }, { "🖕🏿" }, { "✍️" }, { "✍🏻" },
		{ "✍🏼" }, { "✍🏽" }, { "✍🏾" }, { "✍🏿" }, { "🙏" }, { "🙏" }, { "🙏🏻" }, { "🙏🏼" }, { "🙏🏽" }, { "🙏🏾" }, { "🙏🏿" }, { "🫵" }, { "🫵🏻" }, { "🫵🏻" }, { "🫵🏼" },
		{ "🫵🏼" }, { "🫵🏽" }, { "🫵🏽" }, { "🫵🏾" }, { "🫵🏾" }, { "🫵🏿" }, { "🫵🏿" }, { "🦶" }, { "🦶🏻" }, { "🦶🏻" }, { "🦶🏼" }, { "🦶🏼" }, { "🦶🏽" }, { "🦶🏽" },
		{ "🦶🏾" }, { "🦶🏾" }, { "🦶🏿" }, { "🦶🏿" }, { "🦵" }, { "🦵🏻" }, { "🦵🏻" }, { "🦵🏼" }, { "🦵🏼" }, { "🦵🏽" }, { "🦵🏽" }, { "🦵🏾" }, { "🦵🏾" }, { "🦵🏿" },
		{ "🦵🏿" }, { "🦿" }, { "💄" }, { "💋" }, { "💋" }, { "👄" }, { "👄" }, { "🫦" }, { "🦷" }, { "👅" }, { "👂" }, { "👂🏻" }, { "👂🏼" }, { "👂🏽" }, { "👂🏾" }, { "👂🏿" },
		{ "🦻" }, { "🦻🏻" }, { "🦻🏻" }, { "🦻🏼" }, { "🦻🏼" }, { "🦻🏽" }, { "🦻🏽" }, { "🦻🏾" }, { "🦻🏾" }, { "🦻🏿" }, { "🦻🏿" }, { "👃" }, { "👃🏻" }, { "👃🏼" },
		{ "👃🏽" }, { "👃🏾" }, { "👃🏿" }, { "👣" }, { "👁️" }, { "👀" }, { "🫀" }, { "🫁" }, { "🧠" }, { "🗣️" }, { "🗣️" }, { "👤" }, { "👥" }, { "🫂" }, { "👶" }, { "👶🏻" },
		{ "👶🏼" }, { "👶🏽" }, { "👶🏾" }, { "👶🏿" }, { "🧒" }, { "🧒🏻" }, { "🧒🏻" }, { "🧒🏼" }, { "🧒🏼" }, { "🧒🏽" }, { "🧒🏽" }, { "🧒🏾" }, { "🧒🏾" }, { "🧒🏿" },
		{ "🧒🏿" }, { "👧" }, { "👧🏻" }, { "👧🏼" }, { "👧🏽" }, { "👧🏾" }, { "👧🏿" }, { "👦" }, { "👦🏻" }, { "👦🏼" }, { "👦🏽" }, { "👦🏾" }, { "👦🏿" }, { "🧑" }, { "🧑" },
		{ "🧑🏻" }, { "🧑🏻" }, { "🧑🏼" }, { "🧑🏼" }, { "🧑🏽" }, { "🧑🏽" }, { "🧑🏾" }, { "🧑🏾" }, { "🧑🏿" }, { "🧑🏿" }, { "👩" }, { "👩🏻" }, { "👩🏼" }, { "👩🏽" },
		{ "👩🏾" }, { "👩🏿" }, { "👨" }, { "👨🏻" }, { "👨🏼" }, { "👨🏽" }, { "👨🏾" }, { "👨🏿" }, { "🧑‍🦱" }, { "🧑🏻‍🦱" }, { "🧑🏻‍🦱" },
		{ "🧑🏼‍🦱" }, { "🧑🏼‍🦱" }, { "🧑🏽‍🦱" }, { "🧑🏽‍🦱" }, { "🧑🏾‍🦱" }, { "🧑🏾‍🦱" }, { "🧑🏿‍🦱" },
		{ "🧑🏿‍🦱" }, { "👩‍🦱" }, { "👩🏻‍🦱" }, { "👩🏻‍🦱" }, { "👩🏼‍🦱" }, { "👩🏼‍🦱" }, { "👩🏽‍🦱" },
		{ "👩🏽‍🦱" }, { "👩🏾‍🦱" }, { "👩🏾‍🦱" }, { "👩🏿‍🦱" }, { "👩🏿‍🦱" }, { "👨‍🦱" }, { "👨🏻‍🦱" },
		{ "👨🏻‍🦱" }, { "👨🏼‍🦱" }, { "👨🏼‍🦱" }, { "👨🏽‍🦱" }, { "👨🏽‍🦱" }, { "👨🏾‍🦱" }, { "👨🏾‍🦱" },
		{ "👨🏿‍🦱" }, { "👨🏿‍🦱" }, { "🧑‍🦰" }, { "🧑🏻‍🦰" }, { "🧑🏻‍🦰" }, { "🧑🏼‍🦰" }, { "🧑🏼‍🦰" },
		{ "🧑🏽‍🦰" }, { "🧑🏽‍🦰" }, { "🧑🏾‍🦰" }, { "🧑🏾‍🦰" }, { "🧑🏿‍🦰" }, { "🧑🏿‍🦰" }, { "👩‍🦰" },
		{ "👩🏻‍🦰" }, { "👩🏻‍🦰" }, { "👩🏼‍🦰" }, { "👩🏼‍🦰" }, { "👩🏽‍🦰" }, { "👩🏽‍🦰" }, { "👩🏾‍🦰" },
		{ "👩🏾‍🦰" }, { "👩🏿‍🦰" }, { "👩🏿‍🦰" }, { "👨‍🦰" }, { "👨‍🦰" }, { "👨🏻‍🦰" }, { "👨🏻‍🦰" },
		{ "👨🏼‍🦰" }, { "👨🏼‍🦰" }, { "👨🏽‍🦰" }, { "👨🏽‍🦰" }, { "👨🏾‍🦰" }, { "👨🏾‍🦰" }, { "👨🏿‍🦰" },
		{ "👨🏿‍🦰" }, { "👱" }, { "👱" }, { "👱🏻" }, { "👱🏻" }, { "👱🏼" }, { "👱🏼" }, { "👱🏽" }, { "👱🏽" }, { "👱🏾" }, { "👱🏾" }, { "👱🏿" }, { "👱🏿" },
		{ "👱‍♀️" }, { "👱🏻‍♀️" }, { "👱🏻‍♀️" }, { "👱🏼‍♀️" }, { "👱🏼‍♀️" }, { "👱🏽‍♀️" }, { "👱🏽‍♀️" },
		{ "👱🏾‍♀️" }, { "👱🏾‍♀️" }, { "👱🏿‍♀️" }, { "👱🏿‍♀️" }, { "👱‍♂️" }, { "👱🏻‍♂️" }, { "👱🏻‍♂️" },
		{ "👱🏼‍♂️" }, { "👱🏼‍♂️" }, { "👱🏽‍♂️" }, { "👱🏽‍♂️" }, { "👱🏾‍♂️" }, { "👱🏾‍♂️" },
		{ "👱🏿‍♂️" }, { "👱🏿‍♂️" }, { "🧑‍🦳" }, { "🧑🏻‍🦳" }, { "🧑🏻‍🦳" }, { "🧑🏼‍🦳" }, { "🧑🏼‍🦳" },
		{ "🧑🏽‍🦳" }, { "🧑🏽‍🦳" }, { "🧑🏾‍🦳" }, { "🧑🏾‍🦳" }, { "🧑🏿‍🦳" }, { "🧑🏿‍🦳" }, { "👩‍🦳" },
		{ "👩🏻‍🦳" }, { "👩🏻‍🦳" }, { "👩🏼‍🦳" }, { "👩🏼‍🦳" }, { "👩🏽‍🦳" }, { "👩🏽‍🦳" }, { "👩🏾‍🦳" },
		{ "👩🏾‍🦳" }, { "👩🏿‍🦳" }, { "👩🏿‍🦳" }, { "👨‍🦳" }, { "👨🏻‍🦳" }, { "👨🏻‍🦳" }, { "👨🏼‍🦳" },
		{ "👨🏼‍🦳" }, { "👨🏽‍🦳" }, { "👨🏽‍🦳" }, { "👨🏾‍🦳" }, { "👨🏾‍🦳" }, { "👨🏿‍🦳" }, { "👨🏿‍🦳" },
		{ "🧑‍🦲" }, { "🧑🏻‍🦲" }, { "🧑🏻‍🦲" }, { "🧑🏼‍🦲" }, { "🧑🏼‍🦲" }, { "🧑🏽‍🦲" }, { "🧑🏽‍🦲" },
		{ "🧑🏾‍🦲" }, { "🧑🏾‍🦲" }, { "🧑🏿‍🦲" }, { "🧑🏿‍🦲" }, { "👩‍🦲" }, { "👩🏻‍🦲" }, { "👩🏻‍🦲" },
		{ "👩🏼‍🦲" }, { "👩🏼‍🦲" }, { "👩🏽‍🦲" }, { "👩🏽‍🦲" }, { "👩🏾‍🦲" }, { "👩🏾‍🦲" }, { "👩🏿‍🦲" },
		{ "👩🏿‍🦲" }, { "👨‍🦲" }, { "👨🏻‍🦲" }, { "👨🏻‍🦲" }, { "👨🏼‍🦲" }, { "👨🏼‍🦲" }, { "👨🏽‍🦲" },
		{ "👨🏽‍🦲" }, { "👨🏾‍🦲" }, { "👨🏾‍🦲" }, { "👨🏿‍🦲" }, { "👨🏿‍🦲" }, { "🧔" }, { "🧔" }, { "🧔🏻" }, { "🧔🏻" }, { "🧔🏼" },
		{ "🧔🏼" }, { "🧔🏽" }, { "🧔🏽" }, { "🧔🏾" }, { "🧔🏾" }, { "🧔🏿" }, { "🧔🏿" }, { "🧔‍♀️" }, { "🧔🏻‍♀️" }, { "🧔🏻‍♀️" },
		{ "🧔🏼‍♀️" }, { "🧔🏼‍♀️" }, { "🧔🏽‍♀️" }, { "🧔🏽‍♀️" }, { "🧔🏾‍♀️" }, { "🧔🏾‍♀️" },
		{ "🧔🏿‍♀️" }, { "🧔🏿‍♀️" }, { "🧔‍♂️" }, { "🧔🏻‍♂️" }, { "🧔🏻‍♂️" }, { "🧔🏼‍♂️" }, { "🧔🏼‍♂️" },
		{ "🧔🏽‍♂️" }, { "🧔🏽‍♂️" }, { "🧔🏾‍♂️" }, { "🧔🏾‍♂️" }, { "🧔🏿‍♂️" }, { "🧔🏿‍♂️" }, { "🧓" }, { "🧓" },
		{ "🧓🏻" }, { "🧓🏻" }, { "🧓🏼" }, { "🧓🏼" }, { "🧓🏽" }, { "🧓🏽" }, { "🧓🏾" }, { "🧓🏾" }, { "🧓🏿" }, { "🧓🏿" }, { "👵" }, { "👵" }, { "👵" }, { "👵🏻" },
		{ "👵🏻" }, { "👵🏼" }, { "👵🏼" }, { "👵🏽" }, { "👵🏽" }, { "👵🏾" }, { "👵🏾" }, { "👵🏿" }, { "👵🏿" }, { "👴" }, { "👴" }, { "👴🏻" }, { "👴🏼" }, { "👴🏽" },
		{ "👴🏾" }, { "👴🏿" }, { "👲" }, { "👲" }, { "👲🏻" }, { "👲🏻" }, { "👲🏼" }, { "👲🏼" }, { "👲🏽" }, { "👲🏽" }, { "👲🏾" }, { "👲🏾" }, { "👲🏿" }, { "👲🏿" },
		{ "👳" }, { "👳" }, { "👳🏻" }, { "👳🏻" }, { "👳🏼" }, { "👳🏼" }, { "👳🏽" }, { "👳🏽" }, { "👳🏾" }, { "👳🏾" }, { "👳🏿" }, { "👳🏿" }, { "👳‍♀️" },
		{ "👳🏻‍♀️" }, { "👳🏻‍♀️" }, { "👳🏼‍♀️" }, { "👳🏼‍♀️" }, { "👳🏽‍♀️" }, { "👳🏽‍♀️" },
		{ "👳🏾‍♀️" }, { "👳🏾‍♀️" }, { "👳🏿‍♀️" }, { "👳🏿‍♀️" }, { "👳‍♂️" }, { "👳🏻‍♂️" }, { "👳🏻‍♂️" },
		{ "👳🏼‍♂️" }, { "👳🏼‍♂️" }, { "👳🏽‍♂️" }, { "👳🏽‍♂️" }, { "👳🏾‍♂️" }, { "👳🏾‍♂️" },
		{ "👳🏿‍♂️" }, { "👳🏿‍♂️" }, { "🧕" }, { "🧕🏻" }, { "🧕🏻" }, { "🧕🏼" }, { "🧕🏼" }, { "🧕🏽" }, { "🧕🏽" }, { "🧕🏾" }, { "🧕🏾" }, { "🧕🏿" },
		{ "🧕🏿" }, { "👮" }, { "👮" }, { "👮🏻" }, { "👮🏻" }, { "👮🏼" }, { "👮🏼" }, { "👮🏽" }, { "👮🏽" }, { "👮🏾" }, { "👮🏾" }, { "👮🏿" }, { "👮🏿" }, { "👮‍♀️" },
		{ "👮🏻‍♀️" }, { "👮🏻‍♀️" }, { "👮🏼‍♀️" }, { "👮🏼‍♀️" }, { "👮🏽‍♀️" }, { "👮🏽‍♀️" },
		{ "👮🏾‍♀️" }, { "👮🏾‍♀️" }, { "👮🏿‍♀️" }, { "👮🏿‍♀️" }, { "👮‍♂️" }, { "👮🏻‍♂️" }, { "👮🏻‍♂️" },
		{ "👮🏼‍♂️" }, { "👮🏼‍♂️" }, { "👮🏽‍♂️" }, { "👮🏽‍♂️" }, { "👮🏾‍♂️" }, { "👮🏾‍♂️" },
		{ "👮🏿‍♂️" }, { "👮🏿‍♂️" }, { "👷" }, { "👷🏻" }, { "👷🏼" }, { "👷🏽" }, { "👷🏾" }, { "👷🏿" }, { "👷‍♀️" }, { "👷🏻‍♀️" },
		{ "👷🏻‍♀️" }, { "👷🏼‍♀️" }, { "👷🏼‍♀️" }, { "👷🏽‍♀️" }, { "👷🏽‍♀️" }, { "👷🏾‍♀️" },
		{ "👷🏾‍♀️" }, { "👷🏿‍♀️" }, { "👷🏿‍♀️" }, { "👷‍♂️" }, { "👷🏻‍♂️" }, { "👷🏻‍♂️" }, { "👷🏼‍♂️" },
		{ "👷🏼‍♂️" }, { "👷🏽‍♂️" }, { "👷🏽‍♂️" }, { "👷🏾‍♂️" }, { "👷🏾‍♂️" }, { "👷🏿‍♂️" },
		{ "👷🏿‍♂️" }, { "💂" }, { "💂" }, { "💂🏻" }, { "💂🏻" }, { "💂🏼" }, { "💂🏼" }, { "💂🏽" }, { "💂🏽" }, { "💂🏾" }, { "💂🏾" }, { "💂🏿" }, { "💂🏿" },
		{ "💂‍♀️" }, { "💂🏻‍♀️" }, { "💂🏻‍♀️" }, { "💂🏼‍♀️" }, { "💂🏼‍♀️" }, { "💂🏽‍♀️" }, { "💂🏽‍♀️" },
		{ "💂🏾‍♀️" }, { "💂🏾‍♀️" }, { "💂🏿‍♀️" }, { "💂🏿‍♀️" }, { "💂‍♂️" }, { "💂🏻‍♂️" }, { "💂🏻‍♂️" },
		{ "💂🏼‍♂️" }, { "💂🏼‍♂️" }, { "💂🏽‍♂️" }, { "💂🏽‍♂️" }, { "💂🏾‍♂️" }, { "💂🏾‍♂️" },
		{ "💂🏿‍♂️" }, { "💂🏿‍♂️" }, { "🕵️" }, { "🕵️" }, { "🕵️" }, { "🕵🏻" }, { "🕵🏻" }, { "🕵🏻" }, { "🕵🏼" }, { "🕵🏼" }, { "🕵🏼" }, { "🕵🏽" },
		{ "🕵🏽" }, { "🕵🏽" }, { "🕵🏾" }, { "🕵🏾" }, { "🕵🏾" }, { "🕵🏿" }, { "🕵🏿" }, { "🕵🏿" }, { "🕵️‍♀️" }, { "🕵🏻‍♀️" }, { "🕵🏻‍♀️" },
		{ "🕵🏼‍♀️" }, { "🕵🏼‍♀️" }, { "🕵🏽‍♀️" }, { "🕵🏽‍♀️" }, { "🕵🏾‍♀️" }, { "🕵🏾‍♀️" },
		{ "🕵🏿‍♀️" }, { "🕵🏿‍♀️" }, { "🕵️‍♂️" }, { "🕵🏻‍♂️" }, { "🕵🏻‍♂️" }, { "🕵🏼‍♂️" },
		{ "🕵🏼‍♂️" }, { "🕵🏽‍♂️" }, { "🕵🏽‍♂️" }, { "🕵🏾‍♂️" }, { "🕵🏾‍♂️" }, { "🕵🏿‍♂️" },
		{ "🕵🏿‍♂️" }, { "🧑‍⚕️" }, { "🧑🏻‍⚕️" }, { "🧑🏻‍⚕️" }, { "🧑🏼‍⚕️" }, { "🧑🏼‍⚕️" }, { "🧑🏽‍⚕️" },
		{ "🧑🏽‍⚕️" }, { "🧑🏾‍⚕️" }, { "🧑🏾‍⚕️" }, { "🧑🏿‍⚕️" }, { "🧑🏿‍⚕️" }, { "👩‍⚕️" }, { "👩🏻‍⚕️" },
		{ "👩🏻‍⚕️" }, { "👩🏼‍⚕️" }, { "👩🏼‍⚕️" }, { "👩🏽‍⚕️" }, { "👩🏽‍⚕️" }, { "👩🏾‍⚕️" },
		{ "👩🏾‍⚕️" }, { "👩🏿‍⚕️" }, { "👩🏿‍⚕️" }, { "👨‍⚕️" }, { "👨🏻‍⚕️" }, { "👨🏻‍⚕️" }, { "👨🏼‍⚕️" },
		{ "👨🏼‍⚕️" }, { "👨🏽‍⚕️" }, { "👨🏽‍⚕️" }, { "👨🏾‍⚕️" }, { "👨🏾‍⚕️" }, { "👨🏿‍⚕️" },
		{ "👨🏿‍⚕️" }, { "🧑‍🌾" }, { "🧑🏻‍🌾" }, { "🧑🏻‍🌾" }, { "🧑🏼‍🌾" }, { "🧑🏼‍🌾" }, { "🧑🏽‍🌾" },
		{ "🧑🏽‍🌾" }, { "🧑🏾‍🌾" }, { "🧑🏾‍🌾" }, { "🧑🏿‍🌾" }, { "🧑🏿‍🌾" }, { "👩‍🌾" }, { "👩🏻‍🌾" },
		{ "👩🏻‍🌾" }, { "👩🏼‍🌾" }, { "👩🏼‍🌾" }, { "👩🏽‍🌾" }, { "👩🏽‍🌾" }, { "👩🏾‍🌾" }, { "👩🏾‍🌾" },
		{ "👩🏿‍🌾" }, { "👩🏿‍🌾" }, { "👨‍🌾" }, { "👨🏻‍🌾" }, { "👨🏻‍🌾" }, { "👨🏼‍🌾" }, { "👨🏼‍🌾" },
		{ "👨🏽‍🌾" }, { "👨🏽‍🌾" }, { "👨🏾‍🌾" }, { "👨🏾‍🌾" }, { "👨🏿‍🌾" }, { "👨🏿‍🌾" }, { "🧑‍🍳" },
		{ "🧑🏻‍🍳" }, { "🧑🏻‍🍳" }, { "🧑🏼‍🍳" }, { "🧑🏼‍🍳" }, { "🧑🏽‍🍳" }, { "🧑🏽‍🍳" }, { "🧑🏾‍🍳" },
		{ "🧑🏾‍🍳" }, { "🧑🏿‍🍳" }, { "🧑🏿‍🍳" }, { "👩‍🍳" }, { "👩🏻‍🍳" }, { "👩🏻‍🍳" }, { "👩🏼‍🍳" },
		{ "👩🏼‍🍳" }, { "👩🏽‍🍳" }, { "👩🏽‍🍳" }, { "👩🏾‍🍳" }, { "👩🏾‍🍳" }, { "👩🏿‍🍳" }, { "👩🏿‍🍳" },
		{ "👨‍🍳" }, { "👨🏻‍🍳" }, { "👨🏻‍🍳" }, { "👨🏼‍🍳" }, { "👨🏼‍🍳" }, { "👨🏽‍🍳" }, { "👨🏽‍🍳" },
		{ "👨🏾‍🍳" }, { "👨🏾‍🍳" }, { "👨🏿‍🍳" }, { "👨🏿‍🍳" }, { "🧑‍🎓" }, { "🧑🏻‍🎓" }, { "🧑🏻‍🎓" },
		{ "🧑🏼‍🎓" }, { "🧑🏼‍🎓" }, { "🧑🏽‍🎓" }, { "🧑🏽‍🎓" }, { "🧑🏾‍🎓" }, { "🧑🏾‍🎓" }, { "🧑🏿‍🎓" },
		{ "🧑🏿‍🎓" }, { "👩‍🎓" }, { "👩🏻‍🎓" }, { "👩🏻‍🎓" }, { "👩🏼‍🎓" }, { "👩🏼‍🎓" }, { "👩🏽‍🎓" },
		{ "👩🏽‍🎓" }, { "👩🏾‍🎓" }, { "👩🏾‍🎓" }, { "👩🏿‍🎓" }, { "👩🏿‍🎓" }, { "👨‍🎓" }, { "👨🏻‍🎓" },
		{ "👨🏻‍🎓" }, { "👨🏼‍🎓" }, { "👨🏼‍🎓" }, { "👨🏽‍🎓" }, { "👨🏽‍🎓" }, { "👨🏾‍🎓" }, { "👨🏾‍🎓" },
		{ "👨🏿‍🎓" }, { "👨🏿‍🎓" }, { "🧑‍🎤" }, { "🧑🏻‍🎤" }, { "🧑🏻‍🎤" }, { "🧑🏼‍🎤" }, { "🧑🏼‍🎤" },
		{ "🧑🏽‍🎤" }, { "🧑🏽‍🎤" }, { "🧑🏾‍🎤" }, { "🧑🏾‍🎤" }, { "🧑🏿‍🎤" }, { "🧑🏿‍🎤" }, { "👩‍🎤" },
		{ "👩🏻‍🎤" }, { "👩🏻‍🎤" }, { "👩🏼‍🎤" }, { "👩🏼‍🎤" }, { "👩🏽‍🎤" }, { "👩🏽‍🎤" }, { "👩🏾‍🎤" },
		{ "👩🏾‍🎤" }, { "👩🏿‍🎤" }, { "👩🏿‍🎤" }, { "👨‍🎤" }, { "👨🏻‍🎤" }, { "👨🏻‍🎤" }, { "👨🏼‍🎤" },
		{ "👨🏼‍🎤" }, { "👨🏽‍🎤" }, { "👨🏽‍🎤" }, { "👨🏾‍🎤" }, { "👨🏾‍🎤" }, { "👨🏿‍🎤" }, { "👨🏿‍🎤" },
		{ "🧑‍🏫" }, { "🧑🏻‍🏫" }, { "🧑🏻‍🏫" }, { "🧑🏼‍🏫" }, { "🧑🏼‍🏫" }, { "🧑🏽‍🏫" }, { "🧑🏽‍🏫" },
		{ "🧑🏾‍🏫" }, { "🧑🏾‍🏫" }, { "🧑🏿‍🏫" }, { "🧑🏿‍🏫" }, { "👩‍🏫" }, { "👩🏻‍🏫" }, { "👩🏻‍🏫" },
		{ "👩🏼‍🏫" }, { "👩🏼‍🏫" }, { "👩🏽‍🏫" }, { "👩🏽‍🏫" }, { "👩🏾‍🏫" }, { "👩🏾‍🏫" }, { "👩🏿‍🏫" },
		{ "👩🏿‍🏫" }, { "👨‍🏫" }, { "👨🏻‍🏫" }, { "👨🏻‍🏫" }, { "👨🏼‍🏫" }, { "👨🏼‍🏫" }, { "👨🏽‍🏫" },
		{ "👨🏽‍🏫" }, { "👨🏾‍🏫" }, { "👨🏾‍🏫" }, { "👨🏿‍🏫" }, { "👨🏿‍🏫" }, { "🧑‍🏭" }, { "🧑🏻‍🏭" },
		{ "🧑🏻‍🏭" }, { "🧑🏼‍🏭" }, { "🧑🏼‍🏭" }, { "🧑🏽‍🏭" }, { "🧑🏽‍🏭" }, { "🧑🏾‍🏭" }, { "🧑🏾‍🏭" },
		{ "🧑🏿‍🏭" }, { "🧑🏿‍🏭" }, { "👩‍🏭" }, { "👩🏻‍🏭" }, { "👩🏻‍🏭" }, { "👩🏼‍🏭" }, { "👩🏼‍🏭" },
		{ "👩🏽‍🏭" }, { "👩🏽‍🏭" }, { "👩🏾‍🏭" }, { "👩🏾‍🏭" }, { "👩🏿‍🏭" }, { "👩🏿‍🏭" }, { "👨‍🏭" },
		{ "👨🏻‍🏭" }, { "👨🏻‍🏭" }, { "👨🏼‍🏭" }, { "👨🏼‍🏭" }, { "👨🏽‍🏭" }, { "👨🏽‍🏭" }, { "👨🏾‍🏭" },
		{ "👨🏾‍🏭" }, { "👨🏿‍🏭" }, { "👨🏿‍🏭" }, { "🧑‍💻" }, { "🧑🏻‍💻" }, { "🧑🏻‍💻" }, { "🧑🏼‍💻" },
		{ "🧑🏼‍💻" }, { "🧑🏽‍💻" }, { "🧑🏽‍💻" }, { "🧑🏾‍💻" }, { "🧑🏾‍💻" }, { "🧑🏿‍💻" }, { "🧑🏿‍💻" },
		{ "👩‍💻" }, { "👩🏻‍💻" }, { "👩🏻‍💻" }, { "👩🏼‍💻" }, { "👩🏼‍💻" }, { "👩🏽‍💻" }, { "👩🏽‍💻" },
		{ "👩🏾‍💻" }, { "👩🏾‍💻" }, { "👩🏿‍💻" }, { "👩🏿‍💻" }, { "👨‍💻" }, { "👨🏻‍💻" }, { "👨🏻‍💻" },
		{ "👨🏼‍💻" }, { "👨🏼‍💻" }, { "👨🏽‍💻" }, { "👨🏽‍💻" }, { "👨🏾‍💻" }, { "👨🏾‍💻" }, { "👨🏿‍💻" },
		{ "👨🏿‍💻" }, { "🧑‍💼" }, { "🧑🏻‍💼" }, { "🧑🏻‍💼" }, { "🧑🏼‍💼" }, { "🧑🏼‍💼" }, { "🧑🏽‍💼" },
		{ "🧑🏽‍💼" }, { "🧑🏾‍💼" }, { "🧑🏾‍💼" }, { "🧑🏿‍💼" }, { "🧑🏿‍💼" }, { "👩‍💼" }, { "👩🏻‍💼" },
		{ "👩🏻‍💼" }, { "👩🏼‍💼" }, { "👩🏼‍💼" }, { "👩🏽‍💼" }, { "👩🏽‍💼" }, { "👩🏾‍💼" }, { "👩🏾‍💼" },
		{ "👩🏿‍💼" }, { "👩🏿‍💼" }, { "👨‍💼" }, { "👨🏻‍💼" }, { "👨🏻‍💼" }, { "👨🏼‍💼" }, { "👨🏼‍💼" },
		{ "👨🏽‍💼" }, { "👨🏽‍💼" }, { "👨🏾‍💼" }, { "👨🏾‍💼" }, { "👨🏿‍💼" }, { "👨🏿‍💼" }, { "🧑‍🔧" },
		{ "🧑🏻‍🔧" }, { "🧑🏻‍🔧" }, { "🧑🏼‍🔧" }, { "🧑🏼‍🔧" }, { "🧑🏽‍🔧" }, { "🧑🏽‍🔧" }, { "🧑🏾‍🔧" },
		{ "🧑🏾‍🔧" }, { "🧑🏿‍🔧" }, { "🧑🏿‍🔧" }, { "👩‍🔧" }, { "👩🏻‍🔧" }, { "👩🏻‍🔧" }, { "👩🏼‍🔧" },
		{ "👩🏼‍🔧" }, { "👩🏽‍🔧" }, { "👩🏽‍🔧" }, { "👩🏾‍🔧" }, { "👩🏾‍🔧" }, { "👩🏿‍🔧" }, { "👩🏿‍🔧" },
		{ "👨‍🔧" }, { "👨🏻‍🔧" }, { "👨🏻‍🔧" }, { "👨🏼‍🔧" }, { "👨🏼‍🔧" }, { "👨🏽‍🔧" }, { "👨🏽‍🔧" },
		{ "👨🏾‍🔧" }, { "👨🏾‍🔧" }, { "👨🏿‍🔧" }, { "👨🏿‍🔧" }, { "🧑‍🔬" }, { "🧑🏻‍🔬" }, { "🧑🏻‍🔬" },
		{ "🧑🏼‍🔬" }, { "🧑🏼‍🔬" }, { "🧑🏽‍🔬" }, { "🧑🏽‍🔬" }, { "🧑🏾‍🔬" }, { "🧑🏾‍🔬" }, { "🧑🏿‍🔬" },
		{ "🧑🏿‍🔬" }, { "👩‍🔬" }, { "👩🏻‍🔬" }, { "👩🏻‍🔬" }, { "👩🏼‍🔬" }, { "👩🏼‍🔬" }, { "👩🏽‍🔬" },
		{ "👩🏽‍🔬" }, { "👩🏾‍🔬" }, { "👩🏾‍🔬" }, { "👩🏿‍🔬" }, { "👩🏿‍🔬" }, { "👨‍🔬" }, { "👨🏻‍🔬" },
		{ "👨🏻‍🔬" }, { "👨🏼‍🔬" }, { "👨🏼‍🔬" }, { "👨🏽‍🔬" }, { "👨🏽‍🔬" }, { "👨🏾‍🔬" }, { "👨🏾‍🔬" },
		{ "👨🏿‍🔬" }, { "👨🏿‍🔬" }, { "🧑‍🎨" }, { "🧑🏻‍🎨" }, { "🧑🏻‍🎨" }, { "🧑🏼‍🎨" }, { "🧑🏼‍🎨" },
		{ "🧑🏽‍🎨" }, { "🧑🏽‍🎨" }, { "🧑🏾‍🎨" }, { "🧑🏾‍🎨" }, { "🧑🏿‍🎨" }, { "🧑🏿‍🎨" }, { "👩‍🎨" },
		{ "👩🏻‍🎨" }, { "👩🏻‍🎨" }, { "👩🏼‍🎨" }, { "👩🏼‍🎨" }, { "👩🏽‍🎨" }, { "👩🏽‍🎨" }, { "👩🏾‍🎨" },
		{ "👩🏾‍🎨" }, { "👩🏿‍🎨" }, { "👩🏿‍🎨" }, { "👨‍🎨" }, { "👨🏻‍🎨" }, { "👨🏻‍🎨" }, { "👨🏼‍🎨" },
		{ "👨🏼‍🎨" }, { "👨🏽‍🎨" }, { "👨🏽‍🎨" }, { "👨🏾‍🎨" }, { "👨🏾‍🎨" }, { "👨🏿‍🎨" }, { "👨🏿‍🎨" },
		{ "🧑‍🚒" }, { "🧑🏻‍🚒" }, { "🧑🏻‍🚒" }, { "🧑🏼‍🚒" }, { "🧑🏼‍🚒" }, { "🧑🏽‍🚒" }, { "🧑🏽‍🚒" },
		{ "🧑🏾‍🚒" }, { "🧑🏾‍🚒" }, { "🧑🏿‍🚒" }, { "🧑🏿‍🚒" }, { "👩‍🚒" }, { "👩🏻‍🚒" }, { "👩🏻‍🚒" },
		{ "👩🏼‍🚒" }, { "👩🏼‍🚒" }, { "👩🏽‍🚒" }, { "👩🏽‍🚒" }, { "👩🏾‍🚒" }, { "👩🏾‍🚒" }, { "👩🏿‍🚒" },
		{ "👩🏿‍🚒" }, { "👨‍🚒" }, { "👨🏻‍🚒" }, { "👨🏻‍🚒" }, { "👨🏼‍🚒" }, { "👨🏼‍🚒" }, { "👨🏽‍🚒" },
		{ "👨🏽‍🚒" }, { "👨🏾‍🚒" }, { "👨🏾‍🚒" }, { "👨🏿‍🚒" }, { "👨🏿‍🚒" }, { "🧑‍✈️" }, { "🧑🏻‍✈️" },
		{ "🧑🏻‍✈️" }, { "🧑🏼‍✈️" }, { "🧑🏼‍✈️" }, { "🧑🏽‍✈️" }, { "🧑🏽‍✈️" }, { "🧑🏾‍✈️" },
		{ "🧑🏾‍✈️" }, { "🧑🏿‍✈️" }, { "🧑🏿‍✈️" }, { "👩‍✈️" }, { "👩🏻‍✈️" }, { "👩🏻‍✈️" }, { "👩🏼‍✈️" },
		{ "👩🏼‍✈️" }, { "👩🏽‍✈️" }, { "👩🏽‍✈️" }, { "👩🏾‍✈️" }, { "👩🏾‍✈️" }, { "👩🏿‍✈️" },
		{ "👩🏿‍✈️" }, { "👨‍✈️" }, { "👨🏻‍✈️" }, { "👨🏻‍✈️" }, { "👨🏼‍✈️" }, { "👨🏼‍✈️" }, { "👨🏽‍✈️" },
		{ "👨🏽‍✈️" }, { "👨🏾‍✈️" }, { "👨🏾‍✈️" }, { "👨🏿‍✈️" }, { "👨🏿‍✈️" }, { "🧑‍🚀" }, { "🧑🏻‍🚀" },
		{ "🧑🏻‍🚀" }, { "🧑🏼‍🚀" }, { "🧑🏼‍🚀" }, { "🧑🏽‍🚀" }, { "🧑🏽‍🚀" }, { "🧑🏾‍🚀" }, { "🧑🏾‍🚀" },
		{ "🧑🏿‍🚀" }, { "🧑🏿‍🚀" }, { "👩‍🚀" }, { "👩🏻‍🚀" }, { "👩🏻‍🚀" }, { "👩🏼‍🚀" }, { "👩🏼‍🚀" },
		{ "👩🏽‍🚀" }, { "👩🏽‍🚀" }, { "👩🏾‍🚀" }, { "👩🏾‍🚀" }, { "👩🏿‍🚀" }, { "👩🏿‍🚀" }, { "👨‍🚀" },
		{ "👨🏻‍🚀" }, { "👨🏻‍🚀" }, { "👨🏼‍🚀" }, { "👨🏼‍🚀" }, { "👨🏽‍🚀" }, { "👨🏽‍🚀" }, { "👨🏾‍🚀" },
		{ "👨🏾‍🚀" }, { "👨🏿‍🚀" }, { "👨🏿‍🚀" }, { "🧑‍⚖️" }, { "🧑🏻‍⚖️" }, { "🧑🏻‍⚖️" }, { "🧑🏼‍⚖️" },
		{ "🧑🏼‍⚖️" }, { "🧑🏽‍⚖️" }, { "🧑🏽‍⚖️" }, { "🧑🏾‍⚖️" }, { "🧑🏾‍⚖️" }, { "🧑🏿‍⚖️" },
		{ "🧑🏿‍⚖️" }, { "👩‍⚖️" }, { "👩🏻‍⚖️" }, { "👩🏻‍⚖️" }, { "👩🏼‍⚖️" }, { "👩🏼‍⚖️" }, { "👩🏽‍⚖️" },
		{ "👩🏽‍⚖️" }, { "👩🏾‍⚖️" }, { "👩🏾‍⚖️" }, { "👩🏿‍⚖️" }, { "👩🏿‍⚖️" }, { "👨‍⚖️" }, { "👨🏻‍⚖️" },
		{ "👨🏻‍⚖️" }, { "👨🏼‍⚖️" }, { "👨🏼‍⚖️" }, { "👨🏽‍⚖️" }, { "👨🏽‍⚖️" }, { "👨🏾‍⚖️" },
		{ "👨🏾‍⚖️" }, { "👨🏿‍⚖️" }, { "👨🏿‍⚖️" }, { "👰" }, { "👰🏻" }, { "👰🏼" }, { "👰🏽" }, { "👰🏾" }, { "👰🏿" }, { "👰‍♀️" },
		{ "👰‍♀️" }, { "👰🏻‍♀️" }, { "👰🏻‍♀️" }, { "👰🏼‍♀️" }, { "👰🏼‍♀️" }, { "👰🏽‍♀️" }, { "👰🏽‍♀️" },
		{ "👰🏾‍♀️" }, { "👰🏾‍♀️" }, { "👰🏿‍♀️" }, { "👰🏿‍♀️" }, { "👰‍♂️" }, { "👰🏻‍♂️" }, { "👰🏻‍♂️" },
		{ "👰🏼‍♂️" }, { "👰🏼‍♂️" }, { "👰🏽‍♂️" }, { "👰🏽‍♂️" }, { "👰🏾‍♂️" }, { "👰🏾‍♂️" },
		{ "👰🏿‍♂️" }, { "👰🏿‍♂️" }, { "🤵" }, { "🤵🏻" }, { "🤵🏻" }, { "🤵🏼" }, { "🤵🏼" }, { "🤵🏽" }, { "🤵🏽" }, { "🤵🏾" }, { "🤵🏾" }, { "🤵🏿" },
		{ "🤵🏿" }, { "🤵‍♀️" }, { "🤵🏻‍♀️" }, { "🤵🏻‍♀️" }, { "🤵🏼‍♀️" }, { "🤵🏼‍♀️" }, { "🤵🏽‍♀️" },
		{ "🤵🏽‍♀️" }, { "🤵🏾‍♀️" }, { "🤵🏾‍♀️" }, { "🤵🏿‍♀️" }, { "🤵🏿‍♀️" }, { "🤵‍♂️" }, { "🤵🏻‍♂️" },
		{ "🤵🏻‍♂️" }, { "🤵🏼‍♂️" }, { "🤵🏼‍♂️" }, { "🤵🏽‍♂️" }, { "🤵🏽‍♂️" }, { "🤵🏾‍♂️" },
		{ "🤵🏾‍♂️" }, { "🤵🏿‍♂️" }, { "🤵🏿‍♂️" }, { "🫅" }, { "🫅🏻" }, { "🫅🏻" }, { "🫅🏼" }, { "🫅🏼" }, { "🫅🏽" }, { "🫅🏽" }, { "🫅🏾" },
		{ "🫅🏾" }, { "🫅🏿" }, { "🫅🏿" }, { "👸" }, { "👸🏻" }, { "👸🏼" }, { "👸🏽" }, { "👸🏾" }, { "👸🏿" }, { "🤴" }, { "🤴🏻" }, { "🤴🏼" }, { "🤴🏽" }, { "🤴🏾" },
		{ "🤴🏿" }, { "🦸" }, { "🦸🏻" }, { "🦸🏻" }, { "🦸🏼" }, { "🦸🏼" }, { "🦸🏽" }, { "🦸🏽" }, { "🦸🏾" }, { "🦸🏾" }, { "🦸🏿" }, { "🦸🏿" }, { "🦸‍♀️" },
		{ "🦸🏻‍♀️" }, { "🦸🏻‍♀️" }, { "🦸🏼‍♀️" }, { "🦸🏼‍♀️" }, { "🦸🏽‍♀️" }, { "🦸🏽‍♀️" },
		{ "🦸🏾‍♀️" }, { "🦸🏾‍♀️" }, { "🦸🏿‍♀️" }, { "🦸🏿‍♀️" }, { "🦸‍♂️" }, { "🦸🏻‍♂️" }, { "🦸🏻‍♂️" },
		{ "🦸🏼‍♂️" }, { "🦸🏼‍♂️" }, { "🦸🏽‍♂️" }, { "🦸🏽‍♂️" }, { "🦸🏾‍♂️" }, { "🦸🏾‍♂️" },
		{ "🦸🏿‍♂️" }, { "🦸🏿‍♂️" }, { "🦹" }, { "🦹🏻" }, { "🦹🏻" }, { "🦹🏼" }, { "🦹🏼" }, { "🦹🏽" }, { "🦹🏽" }, { "🦹🏾" }, { "🦹🏾" }, { "🦹🏿" },
		{ "🦹🏿" }, { "🦹‍♀️" }, { "🦹🏻‍♀️" }, { "🦹🏻‍♀️" }, { "🦹🏼‍♀️" }, { "🦹🏼‍♀️" }, { "🦹🏽‍♀️" },
		{ "🦹🏽‍♀️" }, { "🦹🏾‍♀️" }, { "🦹🏾‍♀️" }, { "🦹🏿‍♀️" }, { "🦹🏿‍♀️" }, { "🦹‍♂️" }, { "🦹🏻‍♂️" },
		{ "🦹🏻‍♂️" }, { "🦹🏼‍♂️" }, { "🦹🏼‍♂️" }, { "🦹🏽‍♂️" }, { "🦹🏽‍♂️" }, { "🦹🏾‍♂️" },
		{ "🦹🏾‍♂️" }, { "🦹🏿‍♂️" }, { "🦹🏿‍♂️" }, { "🥷" }, { "🥷🏻" }, { "🥷🏻" }, { "🥷🏼" }, { "🥷🏼" }, { "🥷🏽" }, { "🥷🏽" }, { "🥷🏾" },
		{ "🥷🏾" }, { "🥷🏿" }, { "🥷🏿" }, { "🧑‍🎄" }, { "🧑🏻‍🎄" }, { "🧑🏻‍🎄" }, { "🧑🏼‍🎄" }, { "🧑🏼‍🎄" }, { "🧑🏽‍🎄" },
		{ "🧑🏽‍🎄" }, { "🧑🏾‍🎄" }, { "🧑🏾‍🎄" }, { "🧑🏿‍🎄" }, { "🧑🏿‍🎄" }, { "🤶" }, { "🤶" }, { "🤶🏻" }, { "🤶🏻" }, { "🤶🏼" },
		{ "🤶🏼" }, { "🤶🏽" }, { "🤶🏽" }, { "🤶🏾" }, { "🤶🏾" }, { "🤶🏿" }, { "🤶🏿" }, { "🎅" }, { "🎅" }, { "🎅🏻" }, { "🎅🏼" }, { "🎅🏽" }, { "🎅🏾" }, { "🎅🏿" },
		{ "🧙" }, { "🧙🏻" }, { "🧙🏻" }, { "🧙🏼" }, { "🧙🏼" }, { "🧙🏽" }, { "🧙🏽" }, { "🧙🏾" }, { "🧙🏾" }, { "🧙🏿" }, { "🧙🏿" }, { "🧙‍♀️" },
		{ "🧙🏻‍♀️" }, { "🧙🏻‍♀️" }, { "🧙🏼‍♀️" }, { "🧙🏼‍♀️" }, { "🧙🏽‍♀️" }, { "🧙🏽‍♀️" },
		{ "🧙🏾‍♀️" }, { "🧙🏾‍♀️" }, { "🧙🏿‍♀️" }, { "🧙🏿‍♀️" }, { "🧙‍♂️" }, { "🧙🏻‍♂️" }, { "🧙🏻‍♂️" },
		{ "🧙🏼‍♂️" }, { "🧙🏼‍♂️" }, { "🧙🏽‍♂️" }, { "🧙🏽‍♂️" }, { "🧙🏾‍♂️" }, { "🧙🏾‍♂️" },
		{ "🧙🏿‍♂️" }, { "🧙🏿‍♂️" }, { "🧝" }, { "🧝🏻" }, { "🧝🏻" }, { "🧝🏼" }, { "🧝🏼" }, { "🧝🏽" }, { "🧝🏽" }, { "🧝🏾" }, { "🧝🏾" }, { "🧝🏿" },
		{ "🧝🏿" }, { "🧝‍♀️" }, { "🧝🏻‍♀️" }, { "🧝🏻‍♀️" }, { "🧝🏼‍♀️" }, { "🧝🏼‍♀️" }, { "🧝🏽‍♀️" },
		{ "🧝🏽‍♀️" }, { "🧝🏾‍♀️" }, { "🧝🏾‍♀️" }, { "🧝🏿‍♀️" }, { "🧝🏿‍♀️" }, { "🧝‍♂️" }, { "🧝🏻‍♂️" },
		{ "🧝🏻‍♂️" }, { "🧝🏼‍♂️" }, { "🧝🏼‍♂️" }, { "🧝🏽‍♂️" }, { "🧝🏽‍♂️" }, { "🧝🏾‍♂️" },
		{ "🧝🏾‍♂️" }, { "🧝🏿‍♂️" }, { "🧝🏿‍♂️" }, { "🧌" }, { "🧛" }, { "🧛🏻" }, { "🧛🏻" }, { "🧛🏼" }, { "🧛🏼" }, { "🧛🏽" }, { "🧛🏽" },
		{ "🧛🏾" }, { "🧛🏾" }, { "🧛🏿" }, { "🧛🏿" }, { "🧛‍♀️" }, { "🧛🏻‍♀️" }, { "🧛🏻‍♀️" }, { "🧛🏼‍♀️" }, { "🧛🏼‍♀️" },
		{ "🧛🏽‍♀️" }, { "🧛🏽‍♀️" }, { "🧛🏾‍♀️" }, { "🧛🏾‍♀️" }, { "🧛🏿‍♀️" }, { "🧛🏿‍♀️" }, { "🧛‍♂️" },
		{ "🧛🏻‍♂️" }, { "🧛🏻‍♂️" }, { "🧛🏼‍♂️" }, { "🧛🏼‍♂️" }, { "🧛🏽‍♂️" }, { "🧛🏽‍♂️" },
		{ "🧛🏾‍♂️" }, { "🧛🏾‍♂️" }, { "🧛🏿‍♂️" }, { "🧛🏿‍♂️" }, { "🧟" }, { "🧟‍♀️" }, { "🧟‍♂️" }, { "🧞" },
		{ "🧞‍♀️" }, { "🧞‍♂️" }, { "🧜" }, { "🧜🏻" }, { "🧜🏻" }, { "🧜🏼" }, { "🧜🏼" }, { "🧜🏽" }, { "🧜🏽" }, { "🧜🏾" }, { "🧜🏾" }, { "🧜🏿" }, { "🧜🏿" },
		{ "🧜‍♀️" }, { "🧜🏻‍♀️" }, { "🧜🏻‍♀️" }, { "🧜🏼‍♀️" }, { "🧜🏼‍♀️" }, { "🧜🏽‍♀️" }, { "🧜🏽‍♀️" },
		{ "🧜🏾‍♀️" }, { "🧜🏾‍♀️" }, { "🧜🏿‍♀️" }, { "🧜🏿‍♀️" }, { "🧜‍♂️" }, { "🧜🏻‍♂️" }, { "🧜🏻‍♂️" },
		{ "🧜🏼‍♂️" }, { "🧜🏼‍♂️" }, { "🧜🏽‍♂️" }, { "🧜🏽‍♂️" }, { "🧜🏾‍♂️" }, { "🧜🏾‍♂️" },
		{ "🧜🏿‍♂️" }, { "🧜🏿‍♂️" }, { "🧚" }, { "🧚🏻" }, { "🧚🏻" }, { "🧚🏼" }, { "🧚🏼" }, { "🧚🏽" }, { "🧚🏽" }, { "🧚🏾" }, { "🧚🏾" }, { "🧚🏿" },
		{ "🧚🏿" }, { "🧚‍♀️" }, { "🧚🏻‍♀️" }, { "🧚🏻‍♀️" }, { "🧚🏼‍♀️" }, { "🧚🏼‍♀️" }, { "🧚🏽‍♀️" },
		{ "🧚🏽‍♀️" }, { "🧚🏾‍♀️" }, { "🧚🏾‍♀️" }, { "🧚🏿‍♀️" }, { "🧚🏿‍♀️" }, { "🧚‍♂️" }, { "🧚🏻‍♂️" },
		{ "🧚🏻‍♂️" }, { "🧚🏼‍♂️" }, { "🧚🏼‍♂️" }, { "🧚🏽‍♂️" }, { "🧚🏽‍♂️" }, { "🧚🏾‍♂️" },
		{ "🧚🏾‍♂️" }, { "🧚🏿‍♂️" }, { "🧚🏿‍♂️" }, { "👼" }, { "👼" }, { "👼🏻" }, { "👼🏼" }, { "👼🏽" }, { "👼🏾" }, { "👼🏿" }, { "🫄" },
		{ "🫄🏻" }, { "🫄🏻" }, { "🫄🏼" }, { "🫄🏼" }, { "🫄🏽" }, { "🫄🏽" }, { "🫄🏾" }, { "🫄🏾" }, { "🫄🏿" }, { "🫄🏿" }, { "🤰" }, { "🤰" }, { "🤰🏻" }, { "🤰🏻" },
		{ "🤰🏼" }, { "🤰🏼" }, { "🤰🏽" }, { "🤰🏽" }, { "🤰🏾" }, { "🤰🏾" }, { "🤰🏿" }, { "🤰🏿" }, { "🫃" }, { "🫃🏻" }, { "🫃🏻" }, { "🫃🏼" }, { "🫃🏼" }, { "🫃🏽" },
		{ "🫃🏽" }, { "🫃🏾" }, { "🫃🏾" }, { "🫃🏿" }, { "🫃🏿" }, { "🤱" }, { "🤱🏻" }, { "🤱🏻" }, { "🤱🏼" }, { "🤱🏼" }, { "🤱🏽" }, { "🤱🏽" }, { "🤱🏾" }, { "🤱🏾" },
		{ "🤱🏿" }, { "🤱🏿" }, { "🧑‍🍼" }, { "🧑🏻‍🍼" }, { "🧑🏻‍🍼" }, { "🧑🏼‍🍼" }, { "🧑🏼‍🍼" }, { "🧑🏽‍🍼" },
		{ "🧑🏽‍🍼" }, { "🧑🏾‍🍼" }, { "🧑🏾‍🍼" }, { "🧑🏿‍🍼" }, { "🧑🏿‍🍼" }, { "👩‍🍼" }, { "👩🏻‍🍼" },
		{ "👩🏻‍🍼" }, { "👩🏼‍🍼" }, { "👩🏼‍🍼" }, { "👩🏽‍🍼" }, { "👩🏽‍🍼" }, { "👩🏾‍🍼" }, { "👩🏾‍🍼" },
		{ "👩🏿‍🍼" }, { "👩🏿‍🍼" }, { "👨‍🍼" }, { "👨🏻‍🍼" }, { "👨🏻‍🍼" }, { "👨🏼‍🍼" }, { "👨🏼‍🍼" },
		{ "👨🏽‍🍼" }, { "👨🏽‍🍼" }, { "👨🏾‍🍼" }, { "👨🏾‍🍼" }, { "👨🏿‍🍼" }, { "👨🏿‍🍼" }, { "🙇" }, { "🙇" }, { "🙇🏻" },
		{ "🙇🏻" }, { "🙇🏼" }, { "🙇🏼" }, { "🙇🏽" }, { "🙇🏽" }, { "🙇🏾" }, { "🙇🏾" }, { "🙇🏿" }, { "🙇🏿" }, { "🙇‍♀️" }, { "🙇🏻‍♀️" },
		{ "🙇🏻‍♀️" }, { "🙇🏼‍♀️" }, { "🙇🏼‍♀️" }, { "🙇🏽‍♀️" }, { "🙇🏽‍♀️" }, { "🙇🏾‍♀️" },
		{ "🙇🏾‍♀️" }, { "🙇🏿‍♀️" }, { "🙇🏿‍♀️" }, { "🙇‍♂️" }, { "🙇🏻‍♂️" }, { "🙇🏻‍♂️" }, { "🙇🏼‍♂️" },
		{ "🙇🏼‍♂️" }, { "🙇🏽‍♂️" }, { "🙇🏽‍♂️" }, { "🙇🏾‍♂️" }, { "🙇🏾‍♂️" }, { "🙇🏿‍♂️" },
		{ "🙇🏿‍♂️" }, { "💁" }, { "💁" }, { "💁🏻" }, { "💁🏻" }, { "💁🏼" }, { "💁🏼" }, { "💁🏽" }, { "💁🏽" }, { "💁🏾" }, { "💁🏾" }, { "💁🏿" }, { "💁🏿" },
		{ "💁‍♀️" }, { "💁🏻‍♀️" }, { "💁🏻‍♀️" }, { "💁🏼‍♀️" }, { "💁🏼‍♀️" }, { "💁🏽‍♀️" }, { "💁🏽‍♀️" },
		{ "💁🏾‍♀️" }, { "💁🏾‍♀️" }, { "💁🏿‍♀️" }, { "💁🏿‍♀️" }, { "💁‍♂️" }, { "💁🏻‍♂️" }, { "💁🏻‍♂️" },
		{ "💁🏼‍♂️" }, { "💁🏼‍♂️" }, { "💁🏽‍♂️" }, { "💁🏽‍♂️" }, { "💁🏾‍♂️" }, { "💁🏾‍♂️" },
		{ "💁🏿‍♂️" }, { "💁🏿‍♂️" }, { "🙅" }, { "🙅" }, { "🙅🏻" }, { "🙅🏻" }, { "🙅🏼" }, { "🙅🏼" }, { "🙅🏽" }, { "🙅🏽" }, { "🙅🏾" }, { "🙅🏾" },
		{ "🙅🏿" }, { "🙅🏿" }, { "🙅‍♀️" }, { "🙅🏻‍♀️" }, { "🙅🏻‍♀️" }, { "🙅🏼‍♀️" }, { "🙅🏼‍♀️" }, { "🙅🏽‍♀️" },
		{ "🙅🏽‍♀️" }, { "🙅🏾‍♀️" }, { "🙅🏾‍♀️" }, { "🙅🏿‍♀️" }, { "🙅🏿‍♀️" }, { "🙅‍♂️" }, { "🙅🏻‍♂️" },
		{ "🙅🏻‍♂️" }, { "🙅🏼‍♂️" }, { "🙅🏼‍♂️" }, { "🙅🏽‍♂️" }, { "🙅🏽‍♂️" }, { "🙅🏾‍♂️" },
		{ "🙅🏾‍♂️" }, { "🙅🏿‍♂️" }, { "🙅🏿‍♂️" }, { "🙆" }, { "🙆🏻" }, { "🙆🏼" }, { "🙆🏽" }, { "🙆🏾" }, { "🙆🏿" }, { "🙆‍♀️" },
		{ "🙆🏻‍♀️" }, { "🙆🏻‍♀️" }, { "🙆🏼‍♀️" }, { "🙆🏼‍♀️" }, { "🙆🏽‍♀️" }, { "🙆🏽‍♀️" },
		{ "🙆🏾‍♀️" }, { "🙆🏾‍♀️" }, { "🙆🏿‍♀️" }, { "🙆🏿‍♀️" }, { "🙆‍♂️" }, { "🙆🏻‍♂️" }, { "🙆🏻‍♂️" },
		{ "🙆🏼‍♂️" }, { "🙆🏼‍♂️" }, { "🙆🏽‍♂️" }, { "🙆🏽‍♂️" }, { "🙆🏾‍♂️" }, { "🙆🏾‍♂️" },
		{ "🙆🏿‍♂️" }, { "🙆🏿‍♂️" }, { "🙋" }, { "🙋" }, { "🙋🏻" }, { "🙋🏻" }, { "🙋🏼" }, { "🙋🏼" }, { "🙋🏽" }, { "🙋🏽" }, { "🙋🏾" }, { "🙋🏾" },
		{ "🙋🏿" }, { "🙋🏿" }, { "🙋‍♀️" }, { "🙋🏻‍♀️" }, { "🙋🏻‍♀️" }, { "🙋🏼‍♀️" }, { "🙋🏼‍♀️" }, { "🙋🏽‍♀️" },
		{ "🙋🏽‍♀️" }, { "🙋🏾‍♀️" }, { "🙋🏾‍♀️" }, { "🙋🏿‍♀️" }, { "🙋🏿‍♀️" }, { "🙋‍♂️" }, { "🙋🏻‍♂️" },
		{ "🙋🏻‍♂️" }, { "🙋🏼‍♂️" }, { "🙋🏼‍♂️" }, { "🙋🏽‍♂️" }, { "🙋🏽‍♂️" }, { "🙋🏾‍♂️" },
		{ "🙋🏾‍♂️" }, { "🙋🏿‍♂️" }, { "🙋🏿‍♂️" }, { "🧏" }, { "🧏🏻" }, { "🧏🏻" }, { "🧏🏼" }, { "🧏🏼" }, { "🧏🏽" }, { "🧏🏽" }, { "🧏🏾" },
		{ "🧏🏾" }, { "🧏🏿" }, { "🧏🏿" }, { "🧏‍♀️" }, { "🧏🏻‍♀️" }, { "🧏🏻‍♀️" }, { "🧏🏼‍♀️" }, { "🧏🏼‍♀️" },
		{ "🧏🏽‍♀️" }, { "🧏🏽‍♀️" }, { "🧏🏾‍♀️" }, { "🧏🏾‍♀️" }, { "🧏🏿‍♀️" }, { "🧏🏿‍♀️" }, { "🧏‍♂️" },
		{ "🧏🏻‍♂️" }, { "🧏🏻‍♂️" }, { "🧏🏼‍♂️" }, { "🧏🏼‍♂️" }, { "🧏🏽‍♂️" }, { "🧏🏽‍♂️" },
		{ "🧏🏾‍♂️" }, { "🧏🏾‍♂️" }, { "🧏🏿‍♂️" }, { "🧏🏿‍♂️" }, { "🤦" }, { "🤦" }, { "🤦" }, { "🤦🏻" }, { "🤦🏻" }, { "🤦🏻" },
		{ "🤦🏼" }, { "🤦🏼" }, { "🤦🏼" }, { "🤦🏽" }, { "🤦🏽" }, { "🤦🏽" }, { "🤦🏾" }, { "🤦🏾" }, { "🤦🏾" }, { "🤦🏿" }, { "🤦🏿" }, { "🤦🏿" }, { "🤦‍♀️" },
		{ "🤦🏻‍♀️" }, { "🤦🏻‍♀️" }, { "🤦🏼‍♀️" }, { "🤦🏼‍♀️" }, { "🤦🏽‍♀️" }, { "🤦🏽‍♀️" },
		{ "🤦🏾‍♀️" }, { "🤦🏾‍♀️" }, { "🤦🏿‍♀️" }, { "🤦🏿‍♀️" }, { "🤦‍♂️" }, { "🤦🏻‍♂️" }, { "🤦🏻‍♂️" },
		{ "🤦🏼‍♂️" }, { "🤦🏼‍♂️" }, { "🤦🏽‍♂️" }, { "🤦🏽‍♂️" }, { "🤦🏾‍♂️" }, { "🤦🏾‍♂️" },
		{ "🤦🏿‍♂️" }, { "🤦🏿‍♂️" }, { "🤷" }, { "🤷" }, { "🤷🏻" }, { "🤷🏻" }, { "🤷🏼" }, { "🤷🏼" }, { "🤷🏽" }, { "🤷🏽" }, { "🤷🏾" }, { "🤷🏾" },
		{ "🤷🏿" }, { "🤷🏿" }, { "🤷‍♀️" }, { "🤷🏻‍♀️" }, { "🤷🏻‍♀️" }, { "🤷🏼‍♀️" }, { "🤷🏼‍♀️" }, { "🤷🏽‍♀️" },
		{ "🤷🏽‍♀️" }, { "🤷🏾‍♀️" }, { "🤷🏾‍♀️" }, { "🤷🏿‍♀️" }, { "🤷🏿‍♀️" }, { "🤷‍♂️" }, { "🤷🏻‍♂️" },
		{ "🤷🏻‍♂️" }, { "🤷🏼‍♂️" }, { "🤷🏼‍♂️" }, { "🤷🏽‍♂️" }, { "🤷🏽‍♂️" }, { "🤷🏾‍♂️" },
		{ "🤷🏾‍♂️" }, { "🤷🏿‍♂️" }, { "🤷🏿‍♂️" }, { "🙎" }, { "🙎" }, { "🙎🏻" }, { "🙎🏻" }, { "🙎🏼" }, { "🙎🏼" }, { "🙎🏽" }, { "🙎🏽" },
		{ "🙎🏾" }, { "🙎🏾" }, { "🙎🏿" }, { "🙎🏿" }, { "🙎‍♀️" }, { "🙎🏻‍♀️" }, { "🙎🏻‍♀️" }, { "🙎🏼‍♀️" }, { "🙎🏼‍♀️" },
		{ "🙎🏽‍♀️" }, { "🙎🏽‍♀️" }, { "🙎🏾‍♀️" }, { "🙎🏾‍♀️" }, { "🙎🏿‍♀️" }, { "🙎🏿‍♀️" }, { "🙎‍♂️" },
		{ "🙎🏻‍♂️" }, { "🙎🏻‍♂️" }, { "🙎🏼‍♂️" }, { "🙎🏼‍♂️" }, { "🙎🏽‍♂️" }, { "🙎🏽‍♂️" },
		{ "🙎🏾‍♂️" }, { "🙎🏾‍♂️" }, { "🙎🏿‍♂️" }, { "🙎🏿‍♂️" }, { "🙍" }, { "🙍🏻" }, { "🙍🏼" }, { "🙍🏽" }, { "🙍🏾" }, { "🙍🏿" },
		{ "🙍‍♀️" }, { "🙍🏻‍♀️" }, { "🙍🏻‍♀️" }, { "🙍🏼‍♀️" }, { "🙍🏼‍♀️" }, { "🙍🏽‍♀️" }, { "🙍🏽‍♀️" },
		{ "🙍🏾‍♀️" }, { "🙍🏾‍♀️" }, { "🙍🏿‍♀️" }, { "🙍🏿‍♀️" }, { "🙍‍♂️" }, { "🙍🏻‍♂️" }, { "🙍🏻‍♂️" },
		{ "🙍🏼‍♂️" }, { "🙍🏼‍♂️" }, { "🙍🏽‍♂️" }, { "🙍🏽‍♂️" }, { "🙍🏾‍♂️" }, { "🙍🏾‍♂️" },
		{ "🙍🏿‍♂️" }, { "🙍🏿‍♂️" }, { "💇" }, { "💇" }, { "💇🏻" }, { "💇🏻" }, { "💇🏼" }, { "💇🏼" }, { "💇🏽" }, { "💇🏽" }, { "💇🏾" }, { "💇🏾" },
		{ "💇🏿" }, { "💇🏿" }, { "💇‍♀️" }, { "💇🏻‍♀️" }, { "💇🏻‍♀️" }, { "💇🏼‍♀️" }, { "💇🏼‍♀️" }, { "💇🏽‍♀️" },
		{ "💇🏽‍♀️" }, { "💇🏾‍♀️" }, { "💇🏾‍♀️" }, { "💇🏿‍♀️" }, { "💇🏿‍♀️" }, { "💇‍♂️" }, { "💇🏻‍♂️" },
		{ "💇🏻‍♂️" }, { "💇🏼‍♂️" }, { "💇🏼‍♂️" }, { "💇🏽‍♂️" }, { "💇🏽‍♂️" }, { "💇🏾‍♂️" },
		{ "💇🏾‍♂️" }, { "💇🏿‍♂️" }, { "💇🏿‍♂️" }, { "💆" }, { "💆" }, { "💆🏻" }, { "💆🏻" }, { "💆🏼" }, { "💆🏼" }, { "💆🏽" }, { "💆🏽" },
		{ "💆🏾" }, { "💆🏾" }, { "💆🏿" }, { "💆🏿" }, { "💆‍♀️" }, { "💆🏻‍♀️" }, { "💆🏻‍♀️" }, { "💆🏼‍♀️" }, { "💆🏼‍♀️" },
		{ "💆🏽‍♀️" }, { "💆🏽‍♀️" }, { "💆🏾‍♀️" }, { "💆🏾‍♀️" }, { "💆🏿‍♀️" }, { "💆🏿‍♀️" }, { "💆‍♂️" },
		{ "💆🏻‍♂️" }, { "💆🏻‍♂️" }, { "💆🏼‍♂️" }, { "💆🏼‍♂️" }, { "💆🏽‍♂️" }, { "💆🏽‍♂️" },
		{ "💆🏾‍♂️" }, { "💆🏾‍♂️" }, { "💆🏿‍♂️" }, { "💆🏿‍♂️" }, { "🧖" }, { "🧖🏻" }, { "🧖🏻" }, { "🧖🏼" }, { "🧖🏼" }, { "🧖🏽" },
		{ "🧖🏽" }, { "🧖🏾" }, { "🧖🏾" }, { "🧖🏿" }, { "🧖🏿" }, { "🧖‍♀️" }, { "🧖🏻‍♀️" }, { "🧖🏻‍♀️" }, { "🧖🏼‍♀️" },
		{ "🧖🏼‍♀️" }, { "🧖🏽‍♀️" }, { "🧖🏽‍♀️" }, { "🧖🏾‍♀️" }, { "🧖🏾‍♀️" }, { "🧖🏿‍♀️" },
		{ "🧖🏿‍♀️" }, { "🧖‍♂️" }, { "🧖🏻‍♂️" }, { "🧖🏻‍♂️" }, { "🧖🏼‍♂️" }, { "🧖🏼‍♂️" }, { "🧖🏽‍♂️" },
		{ "🧖🏽‍♂️" }, { "🧖🏾‍♂️" }, { "🧖🏾‍♂️" }, { "🧖🏿‍♂️" }, { "🧖🏿‍♂️" }, { "💅" }, { "💅" }, { "💅🏻" }, { "💅🏼" },
		{ "💅🏽" }, { "💅🏾" }, { "💅🏿" }, { "🤳" }, { "🤳🏻" }, { "🤳🏼" }, { "🤳🏽" }, { "🤳🏾" }, { "🤳🏿" }, { "💃" }, { "💃" }, { "💃🏻" }, { "💃🏼" }, { "💃🏽" },
		{ "💃🏾" }, { "💃🏿" }, { "🕺" }, { "🕺" }, { "🕺🏻" }, { "🕺🏻" }, { "🕺🏼" }, { "🕺🏼" }, { "🕺🏽" }, { "🕺🏽" }, { "🕺🏿" }, { "🕺🏿" }, { "🕺🏾" }, { "🕺🏾" },
		{ "👯" }, { "👯" }, { "👯‍♀️" }, { "👯‍♂️" }, { "🕴️" }, { "🕴️" }, { "🕴🏻" }, { "🕴🏻" }, { "🕴🏻" }, { "🕴🏼" }, { "🕴🏼" }, { "🕴🏼" }, { "🕴🏽" },
		{ "🕴🏽" }, { "🕴🏽" }, { "🕴🏾" }, { "🕴🏾" }, { "🕴🏾" }, { "🕴🏿" }, { "🕴🏿" }, { "🕴🏿" }, { "🧑‍🦽" }, { "🧑🏻‍🦽" }, { "🧑🏻‍🦽" },
		{ "🧑🏼‍🦽" }, { "🧑🏼‍🦽" }, { "🧑🏽‍🦽" }, { "🧑🏽‍🦽" }, { "🧑🏾‍🦽" }, { "🧑🏾‍🦽" }, { "🧑🏿‍🦽" },
		{ "🧑🏿‍🦽" }, { "👩‍🦽" }, { "👩🏻‍🦽" }, { "👩🏻‍🦽" }, { "👩🏼‍🦽" }, { "👩🏼‍🦽" }, { "👩🏽‍🦽" },
		{ "👩🏽‍🦽" }, { "👩🏾‍🦽" }, { "👩🏾‍🦽" }, { "👩🏿‍🦽" }, { "👩🏿‍🦽" }, { "👨‍🦽" }, { "👨🏻‍🦽" },
		{ "👨🏻‍🦽" }, { "👨🏼‍🦽" }, { "👨🏼‍🦽" }, { "👨🏽‍🦽" }, { "👨🏽‍🦽" }, { "👨🏾‍🦽" }, { "👨🏾‍🦽" },
		{ "👨🏿‍🦽" }, { "👨🏿‍🦽" }, { "🧑‍🦼" }, { "🧑🏻‍🦼" }, { "🧑🏻‍🦼" }, { "🧑🏼‍🦼" }, { "🧑🏼‍🦼" },
		{ "🧑🏽‍🦼" }, { "🧑🏽‍🦼" }, { "🧑🏾‍🦼" }, { "🧑🏾‍🦼" }, { "🧑🏿‍🦼" }, { "🧑🏿‍🦼" }, { "👩‍🦼" },
		{ "👩🏻‍🦼" }, { "👩🏻‍🦼" }, { "👩🏼‍🦼" }, { "👩🏼‍🦼" }, { "👩🏽‍🦼" }, { "👩🏽‍🦼" }, { "👩🏾‍🦼" },
		{ "👩🏾‍🦼" }, { "👩🏿‍🦼" }, { "👩🏿‍🦼" }, { "👨‍🦼" }, { "👨🏻‍🦼" }, { "👨🏻‍🦼" }, { "👨🏼‍🦼" },
		{ "👨🏼‍🦼" }, { "👨🏽‍🦼" }, { "👨🏽‍🦼" }, { "👨🏾‍🦼" }, { "👨🏾‍🦼" }, { "👨🏿‍🦼" }, { "👨🏿‍🦼" }, { "🚶" },
		{ "🚶" }, { "🚶🏻" }, { "🚶🏻" }, { "🚶🏼" }, { "🚶🏼" }, { "🚶🏽" }, { "🚶🏽" }, { "🚶🏾" }, { "🚶🏾" }, { "🚶🏿" }, { "🚶🏿" }, { "🚶‍♀️" },
		{ "🚶🏻‍♀️" }, { "🚶🏻‍♀️" }, { "🚶🏼‍♀️" }, { "🚶🏼‍♀️" }, { "🚶🏽‍♀️" }, { "🚶🏽‍♀️" },
		{ "🚶🏾‍♀️" }, { "🚶🏾‍♀️" }, { "🚶🏿‍♀️" }, { "🚶🏿‍♀️" }, { "🚶‍♂️" }, { "🚶🏻‍♂️" }, { "🚶🏻‍♂️" },
		{ "🚶🏼‍♂️" }, { "🚶🏼‍♂️" }, { "🚶🏽‍♂️" }, { "🚶🏽‍♂️" }, { "🚶🏾‍♂️" }, { "🚶🏾‍♂️" },
		{ "🚶🏿‍♂️" }, { "🚶🏿‍♂️" }, { "🧑‍🦯" }, { "🧑🏻‍🦯" }, { "🧑🏻‍🦯" }, { "🧑🏼‍🦯" }, { "🧑🏼‍🦯" },
		{ "🧑🏽‍🦯" }, { "🧑🏽‍🦯" }, { "🧑🏾‍🦯" }, { "🧑🏾‍🦯" }, { "🧑🏿‍🦯" }, { "🧑🏿‍🦯" }, { "👩‍🦯" },
		{ "👩🏻‍🦯" }, { "👩🏻‍🦯" }, { "👩🏼‍🦯" }, { "👩🏼‍🦯" }, { "👩🏽‍🦯" }, { "👩🏽‍🦯" }, { "👩🏾‍🦯" },
		{ "👩🏾‍🦯" }, { "👩🏿‍🦯" }, { "👩🏿‍🦯" }, { "👨‍🦯" }, { "👨🏻‍🦯" }, { "👨🏻‍🦯" }, { "👨🏼‍🦯" },
		{ "👨🏼‍🦯" }, { "👨🏽‍🦯" }, { "👨🏽‍🦯" }, { "👨🏾‍🦯" }, { "👨🏾‍🦯" }, { "👨🏿‍🦯" }, { "👨🏿‍🦯" }, { "🧎" },
		{ "🧎🏻" }, { "🧎🏻" }, { "🧎🏼" }, { "🧎🏼" }, { "🧎🏽" }, { "🧎🏽" }, { "🧎🏾" }, { "🧎🏾" }, { "🧎🏿" }, { "🧎🏿" }, { "🧎‍♀️" }, { "🧎🏻‍♀️" },
		{ "🧎🏻‍♀️" }, { "🧎🏼‍♀️" }, { "🧎🏼‍♀️" }, { "🧎🏽‍♀️" }, { "🧎🏽‍♀️" }, { "🧎🏾‍♀️" },
		{ "🧎🏾‍♀️" }, { "🧎🏿‍♀️" }, { "🧎🏿‍♀️" }, { "🧎‍♂️" }, { "🧎🏻‍♂️" }, { "🧎🏻‍♂️" }, { "🧎🏼‍♂️" },
		{ "🧎🏼‍♂️" }, { "🧎🏽‍♂️" }, { "🧎🏽‍♂️" }, { "🧎🏾‍♂️" }, { "🧎🏾‍♂️" }, { "🧎🏿‍♂️" },
		{ "🧎🏿‍♂️" }, { "🏃" }, { "🏃" }, { "🏃🏻" }, { "🏃🏻" }, { "🏃🏼" }, { "🏃🏼" }, { "🏃🏽" }, { "🏃🏽" }, { "🏃🏾" }, { "🏃🏾" }, { "🏃🏿" }, { "🏃🏿" },
		{ "🏃‍♀️" }, { "🏃🏻‍♀️" }, { "🏃🏻‍♀️" }, { "🏃🏼‍♀️" }, { "🏃🏼‍♀️" }, { "🏃🏽‍♀️" }, { "🏃🏽‍♀️" },
		{ "🏃🏾‍♀️" }, { "🏃🏾‍♀️" }, { "🏃🏿‍♀️" }, { "🏃🏿‍♀️" }, { "🏃‍♂️" }, { "🏃🏻‍♂️" }, { "🏃🏻‍♂️" },
		{ "🏃🏼‍♂️" }, { "🏃🏼‍♂️" }, { "🏃🏽‍♂️" }, { "🏃🏽‍♂️" }, { "🏃🏾‍♂️" }, { "🏃🏾‍♂️" },
		{ "🏃🏿‍♂️" }, { "🏃🏿‍♂️" }, { "🧍" }, { "🧍🏻" }, { "🧍🏻" }, { "🧍🏼" }, { "🧍🏼" }, { "🧍🏽" }, { "🧍🏽" }, { "🧍🏾" }, { "🧍🏾" }, { "🧍🏿" },
		{ "🧍🏿" }, { "🧍‍♀️" }, { "🧍🏻‍♀️" }, { "🧍🏻‍♀️" }, { "🧍🏼‍♀️" }, { "🧍🏼‍♀️" }, { "🧍🏽‍♀️" },
		{ "🧍🏽‍♀️" }, { "🧍🏾‍♀️" }, { "🧍🏾‍♀️" }, { "🧍🏿‍♀️" }, { "🧍🏿‍♀️" }, { "🧍‍♂️" }, { "🧍🏻‍♂️" },
		{ "🧍🏻‍♂️" }, { "🧍🏼‍♂️" }, { "🧍🏼‍♂️" }, { "🧍🏽‍♂️" }, { "🧍🏽‍♂️" }, { "🧍🏾‍♂️" },
		{ "🧍🏾‍♂️" }, { "🧍🏿‍♂️" }, { "🧍🏿‍♂️" }, { "🧑‍🤝‍🧑" }, { "🧑🏻‍🤝‍🧑🏻" }, { "🧑🏻‍🤝‍🧑🏻" },
		{ "🧑🏻‍🤝‍🧑🏼" }, { "🧑🏻‍🤝‍🧑🏼" }, { "🧑🏻‍🤝‍🧑🏽" }, { "🧑🏻‍🤝‍🧑🏽" }, { "🧑🏻‍🤝‍🧑🏾" },
		{ "🧑🏻‍🤝‍🧑🏾" }, { "🧑🏻‍🤝‍🧑🏿" }, { "🧑🏻‍🤝‍🧑🏿" }, { "🧑🏼‍🤝‍🧑🏻" }, { "🧑🏼‍🤝‍🧑🏻" },
		{ "🧑🏼‍🤝‍🧑🏼" }, { "🧑🏼‍🤝‍🧑🏼" }, { "🧑🏼‍🤝‍🧑🏽" }, { "🧑🏼‍🤝‍🧑🏽" }, { "🧑🏼‍🤝‍🧑🏾" },
		{ "🧑🏼‍🤝‍🧑🏾" }, { "🧑🏼‍🤝‍🧑🏿" }, { "🧑🏼‍🤝‍🧑🏿" }, { "🧑🏽‍🤝‍🧑🏻" }, { "🧑🏽‍🤝‍🧑🏻" },
		{ "🧑🏽‍🤝‍🧑🏼" }, { "🧑🏽‍🤝‍🧑🏼" }, { "🧑🏽‍🤝‍🧑🏽" }, { "🧑🏽‍🤝‍🧑🏽" }, { "🧑🏽‍🤝‍🧑🏾" },
		{ "🧑🏽‍🤝‍🧑🏾" }, { "🧑🏽‍🤝‍🧑🏿" }, { "🧑🏽‍🤝‍🧑🏿" }, { "🧑🏾‍🤝‍🧑🏻" }, { "🧑🏾‍🤝‍🧑🏻" },
		{ "🧑🏾‍🤝‍🧑🏼" }, { "🧑🏾‍🤝‍🧑🏼" }, { "🧑🏾‍🤝‍🧑🏽" }, { "🧑🏾‍🤝‍🧑🏽" }, { "🧑🏾‍🤝‍🧑🏾" },
		{ "🧑🏾‍🤝‍🧑🏾" }, { "🧑🏾‍🤝‍🧑🏿" }, { "🧑🏾‍🤝‍🧑🏿" }, { "🧑🏿‍🤝‍🧑🏻" }, { "🧑🏿‍🤝‍🧑🏻" },
		{ "🧑🏿‍🤝‍🧑🏼" }, { "🧑🏿‍🤝‍🧑🏼" }, { "🧑🏿‍🤝‍🧑🏽" }, { "🧑🏿‍🤝‍🧑🏽" }, { "🧑🏿‍🤝‍🧑🏾" },
		{ "🧑🏿‍🤝‍🧑🏾" }, { "🧑🏿‍🤝‍🧑🏿" }, { "🧑🏿‍🤝‍🧑🏿" }, { "👫" }, { "👫🏻" }, { "👫🏻" }, { "👩🏻‍🤝‍👨🏼" },
		{ "👩🏻‍🤝‍👨🏼" }, { "👩🏻‍🤝‍👨🏽" }, { "👩🏻‍🤝‍👨🏽" }, { "👩🏻‍🤝‍👨🏾" }, { "👩🏻‍🤝‍👨🏾" },
		{ "👩🏻‍🤝‍👨🏿" }, { "👩🏻‍🤝‍👨🏿" }, { "👩🏼‍🤝‍👨🏻" }, { "👩🏼‍🤝‍👨🏻" }, { "👫🏼" }, { "👫🏼" },
		{ "👩🏼‍🤝‍👨🏽" }, { "👩🏼‍🤝‍👨🏽" }, { "👩🏼‍🤝‍👨🏾" }, { "👩🏼‍🤝‍👨🏾" }, { "👩🏼‍🤝‍👨🏿" },
		{ "👩🏼‍🤝‍👨🏿" }, { "👩🏽‍🤝‍👨🏻" }, { "👩🏽‍🤝‍👨🏻" }, { "👩🏽‍🤝‍👨🏼" }, { "👩🏽‍🤝‍👨🏼" },
		{ "👫🏽" }, { "👫🏽" }, { "👩🏽‍🤝‍👨🏾" }, { "👩🏽‍🤝‍👨🏾" }, { "👩🏽‍🤝‍👨🏿" }, { "👩🏽‍🤝‍👨🏿" },
		{ "👩🏾‍🤝‍👨🏻" }, { "👩🏾‍🤝‍👨🏻" }, { "👩🏾‍🤝‍👨🏼" }, { "👩🏾‍🤝‍👨🏼" }, { "👩🏾‍🤝‍👨🏽" },
		{ "👩🏾‍🤝‍👨🏽" }, { "👫🏾" }, { "👫🏾" }, { "👩🏾‍🤝‍👨🏿" }, { "👩🏾‍🤝‍👨🏿" }, { "👩🏿‍🤝‍👨🏻" },
		{ "👩🏿‍🤝‍👨🏻" }, { "👩🏿‍🤝‍👨🏼" }, { "👩🏿‍🤝‍👨🏼" }, { "👩🏿‍🤝‍👨🏽" }, { "👩🏿‍🤝‍👨🏽" },
		{ "👩🏿‍🤝‍👨🏾" }, { "👩🏿‍🤝‍👨🏾" }, { "👫🏿" }, { "👫🏿" }, { "👭" }, { "👭🏻" }, { "👭🏻" }, { "👩🏻‍🤝‍👩🏼" },
		{ "👩🏻‍🤝‍👩🏼" }, { "👩🏻‍🤝‍👩🏽" }, { "👩🏻‍🤝‍👩🏽" }, { "👩🏻‍🤝‍👩🏾" }, { "👩🏻‍🤝‍👩🏾" },
		{ "👩🏻‍🤝‍👩🏿" }, { "👩🏻‍🤝‍👩🏿" }, { "👩🏼‍🤝‍👩🏻" }, { "👩🏼‍🤝‍👩🏻" }, { "👭🏼" }, { "👭🏼" },
		{ "👩🏼‍🤝‍👩🏽" }, { "👩🏼‍🤝‍👩🏽" }, { "👩🏼‍🤝‍👩🏾" }, { "👩🏼‍🤝‍👩🏾" }, { "👩🏼‍🤝‍👩🏿" },
		{ "👩🏼‍🤝‍👩🏿" }, { "👩🏽‍🤝‍👩🏻" }, { "👩🏽‍🤝‍👩🏻" }, { "👩🏽‍🤝‍👩🏼" }, { "👩🏽‍🤝‍👩🏼" },
		{ "👭🏽" }, { "👭🏽" }, { "👩🏽‍🤝‍👩🏾" }, { "👩🏽‍🤝‍👩🏾" }, { "👩🏽‍🤝‍👩🏿" }, { "👩🏽‍🤝‍👩🏿" },
		{ "👩🏾‍🤝‍👩🏻" }, { "👩🏾‍🤝‍👩🏻" }, { "👩🏾‍🤝‍👩🏼" }, { "👩🏾‍🤝‍👩🏼" }, { "👩🏾‍🤝‍👩🏽" },
		{ "👩🏾‍🤝‍👩🏽" }, { "👭🏾" }, { "👭🏾" }, { "👩🏾‍🤝‍👩🏿" }, { "👩🏾‍🤝‍👩🏿" }, { "👩🏿‍🤝‍👩🏻" },
		{ "👩🏿‍🤝‍👩🏻" }, { "👩🏿‍🤝‍👩🏼" }, { "👩🏿‍🤝‍👩🏼" }, { "👩🏿‍🤝‍👩🏽" }, { "👩🏿‍🤝‍👩🏽" },
		{ "👩🏿‍🤝‍👩🏾" }, { "👩🏿‍🤝‍👩🏾" }, { "👭🏿" }, { "👭🏿" }, { "👬" }, { "👬🏻" }, { "👬🏻" }, { "👨🏻‍🤝‍👨🏼" },
		{ "👨🏻‍🤝‍👨🏼" }, { "👨🏻‍🤝‍👨🏽" }, { "👨🏻‍🤝‍👨🏽" }, { "👨🏻‍🤝‍👨🏾" }, { "👨🏻‍🤝‍👨🏾" },
		{ "👨🏻‍🤝‍👨🏿" }, { "👨🏻‍🤝‍👨🏿" }, { "👨🏼‍🤝‍👨🏻" }, { "👨🏼‍🤝‍👨🏻" }, { "👬🏼" }, { "👬🏼" },
		{ "👨🏼‍🤝‍👨🏽" }, { "👨🏼‍🤝‍👨🏽" }, { "👨🏼‍🤝‍👨🏾" }, { "👨🏼‍🤝‍👨🏾" }, { "👨🏼‍🤝‍👨🏿" },
		{ "👨🏼‍🤝‍👨🏿" }, { "👨🏽‍🤝‍👨🏻" }, { "👨🏽‍🤝‍👨🏻" }, { "👨🏽‍🤝‍👨🏼" }, { "👨🏽‍🤝‍👨🏼" },
		{ "👬🏽" }, { "👬🏽" }, { "👨🏽‍🤝‍👨🏾" }, { "👨🏽‍🤝‍👨🏾" }, { "👨🏽‍🤝‍👨🏿" }, { "👨🏽‍🤝‍👨🏿" },
		{ "👨🏾‍🤝‍👨🏻" }, { "👨🏾‍🤝‍👨🏻" }, { "👨🏾‍🤝‍👨🏼" }, { "👨🏾‍🤝‍👨🏼" }, { "👨🏾‍🤝‍👨🏽" },
		{ "👨🏾‍🤝‍👨🏽" }, { "👬🏾" }, { "👬🏾" }, { "👨🏾‍🤝‍👨🏿" }, { "👨🏾‍🤝‍👨🏿" }, { "👨🏿‍🤝‍👨🏻" },
		{ "👨🏿‍🤝‍👨🏻" }, { "👨🏿‍🤝‍👨🏼" }, { "👨🏿‍🤝‍👨🏼" }, { "👨🏿‍🤝‍👨🏽" }, { "👨🏿‍🤝‍👨🏽" },
		{ "👨🏿‍🤝‍👨🏾" }, { "👨🏿‍🤝‍👨🏾" }, { "👬🏿" }, { "👬🏿" }, { "💑" }, { "💑🏻" }, { "💑🏻" }, { "🧑🏻‍❤️‍🧑🏼" },
		{ "🧑🏻‍❤️‍🧑🏼" }, { "🧑🏻‍❤️‍🧑🏽" }, { "🧑🏻‍❤️‍🧑🏽" }, { "🧑🏻‍❤️‍🧑🏾" },
		{ "🧑🏻‍❤️‍🧑🏾" }, { "🧑🏻‍❤️‍🧑🏿" }, { "🧑🏻‍❤️‍🧑🏿" }, { "🧑🏼‍❤️‍🧑🏻" },
		{ "🧑🏼‍❤️‍🧑🏻" }, { "💑🏼" }, { "💑🏼" }, { "🧑🏼‍❤️‍🧑🏽" }, { "🧑🏼‍❤️‍🧑🏽" }, { "🧑🏼‍❤️‍🧑🏾" },
		{ "🧑🏼‍❤️‍🧑🏾" }, { "🧑🏼‍❤️‍🧑🏿" }, { "🧑🏼‍❤️‍🧑🏿" }, { "🧑🏽‍❤️‍🧑🏻" },
		{ "🧑🏽‍❤️‍🧑🏻" }, { "🧑🏽‍❤️‍🧑🏼" }, { "🧑🏽‍❤️‍🧑🏼" }, { "💑🏽" }, { "💑🏽" }, { "🧑🏽‍❤️‍🧑🏾" },
		{ "🧑🏽‍❤️‍🧑🏾" }, { "🧑🏽‍❤️‍🧑🏿" }, { "🧑🏽‍❤️‍🧑🏿" }, { "🧑🏾‍❤️‍🧑🏻" },
		{ "🧑🏾‍❤️‍🧑🏻" }, { "🧑🏾‍❤️‍🧑🏼" }, { "🧑🏾‍❤️‍🧑🏼" }, { "🧑🏾‍❤️‍🧑🏽" },
		{ "🧑🏾‍❤️‍🧑🏽" }, { "💑🏾" }, { "💑🏾" }, { "🧑🏾‍❤️‍🧑🏿" }, { "🧑🏾‍❤️‍🧑🏿" }, { "🧑🏿‍❤️‍🧑🏻" },
		{ "🧑🏿‍❤️‍🧑🏻" }, { "🧑🏿‍❤️‍🧑🏼" }, { "🧑🏿‍❤️‍🧑🏼" }, { "🧑🏿‍❤️‍🧑🏽" },
		{ "🧑🏿‍❤️‍🧑🏽" }, { "🧑🏿‍❤️‍🧑🏾" }, { "🧑🏿‍❤️‍🧑🏾" }, { "💑🏿" }, { "💑🏿" }, { "👩‍❤️‍👨" },
		{ "👩🏻‍❤️‍👨🏻" }, { "👩🏻‍❤️‍👨🏻" }, { "👩🏻‍❤️‍👨🏼" }, { "👩🏻‍❤️‍👨🏼" },
		{ "👩🏻‍❤️‍👨🏽" }, { "👩🏻‍❤️‍👨🏽" }, { "👩🏻‍❤️‍👨🏾" }, { "👩🏻‍❤️‍👨🏾" },
		{ "👩🏻‍❤️‍👨🏿" }, { "👩🏻‍❤️‍👨🏿" }, { "👩🏼‍❤️‍👨🏻" }, { "👩🏼‍❤️‍👨🏻" },
		{ "👩🏼‍❤️‍👨🏼" }, { "👩🏼‍❤️‍👨🏼" }, { "👩🏼‍❤️‍👨🏽" }, { "👩🏼‍❤️‍👨🏽" },
		{ "👩🏼‍❤️‍👨🏾" }, { "👩🏼‍❤️‍👨🏾" }, { "👩🏼‍❤️‍👨🏿" }, { "👩🏼‍❤️‍👨🏿" },
		{ "👩🏽‍❤️‍👨🏻" }, { "👩🏽‍❤️‍👨🏻" }, { "👩🏽‍❤️‍👨🏼" }, { "👩🏽‍❤️‍👨🏼" },
		{ "👩🏽‍❤️‍👨🏽" }, { "👩🏽‍❤️‍👨🏽" }, { "👩🏽‍❤️‍👨🏾" }, { "👩🏽‍❤️‍👨🏾" },
		{ "👩🏽‍❤️‍👨🏿" }, { "👩🏽‍❤️‍👨🏿" }, { "👩🏾‍❤️‍👨🏻" }, { "👩🏾‍❤️‍👨🏻" },
		{ "👩🏾‍❤️‍👨🏼" }, { "👩🏾‍❤️‍👨🏼" }, { "👩🏾‍❤️‍👨🏽" }, { "👩🏾‍❤️‍👨🏽" },
		{ "👩🏾‍❤️‍👨🏾" }, { "👩🏾‍❤️‍👨🏾" }, { "👩🏾‍❤️‍👨🏿" }, { "👩🏾‍❤️‍👨🏿" },
		{ "👩🏿‍❤️‍👨🏻" }, { "👩🏿‍❤️‍👨🏻" }, { "👩🏿‍❤️‍👨🏼" }, { "👩🏿‍❤️‍👨🏼" },
		{ "👩🏿‍❤️‍👨🏽" }, { "👩🏿‍❤️‍👨🏽" }, { "👩🏿‍❤️‍👨🏾" }, { "👩🏿‍❤️‍👨🏾" },
		{ "👩🏿‍❤️‍👨🏿" }, { "👩🏿‍❤️‍👨🏿" }, { "👩‍❤️‍👩" }, { "👩‍❤️‍👩" }, { "👩🏻‍❤️‍👩🏻" },
		{ "👩🏻‍❤️‍👩🏻" }, { "👩🏻‍❤️‍👩🏼" }, { "👩🏻‍❤️‍👩🏼" }, { "👩🏻‍❤️‍👩🏽" },
		{ "👩🏻‍❤️‍👩🏽" }, { "👩🏻‍❤️‍👩🏾" }, { "👩🏻‍❤️‍👩🏾" }, { "👩🏻‍❤️‍👩🏿" },
		{ "👩🏻‍❤️‍👩🏿" }, { "👩🏼‍❤️‍👩🏻" }, { "👩🏼‍❤️‍👩🏻" }, { "👩🏼‍❤️‍👩🏼" },
		{ "👩🏼‍❤️‍👩🏼" }, { "👩🏼‍❤️‍👩🏽" }, { "👩🏼‍❤️‍👩🏽" }, { "👩🏼‍❤️‍👩🏾" },
		{ "👩🏼‍❤️‍👩🏾" }, { "👩🏼‍❤️‍👩🏿" }, { "👩🏼‍❤️‍👩🏿" }, { "👩🏽‍❤️‍👩🏻" },
		{ "👩🏽‍❤️‍👩🏻" }, { "👩🏽‍❤️‍👩🏼" }, { "👩🏽‍❤️‍👩🏼" }, { "👩🏽‍❤️‍👩🏽" },
		{ "👩🏽‍❤️‍👩🏽" }, { "👩🏽‍❤️‍👩🏾" }, { "👩🏽‍❤️‍👩🏾" }, { "👩🏽‍❤️‍👩🏿" },
		{ "👩🏽‍❤️‍👩🏿" }, { "👩🏾‍❤️‍👩🏻" }, { "👩🏾‍❤️‍👩🏻" }, { "👩🏾‍❤️‍👩🏼" },
		{ "👩🏾‍❤️‍👩🏼" }, { "👩🏾‍❤️‍👩🏽" }, { "👩🏾‍❤️‍👩🏽" }, { "👩🏾‍❤️‍👩🏾" },
		{ "👩🏾‍❤️‍👩🏾" }, { "👩🏾‍❤️‍👩🏿" }, { "👩🏾‍❤️‍👩🏿" }, { "👩🏿‍❤️‍👩🏻" },
		{ "👩🏿‍❤️‍👩🏻" }, { "👩🏿‍❤️‍👩🏼" }, { "👩🏿‍❤️‍👩🏼" }, { "👩🏿‍❤️‍👩🏽" },
		{ "👩🏿‍❤️‍👩🏽" }, { "👩🏿‍❤️‍👩🏾" }, { "👩🏿‍❤️‍👩🏾" }, { "👩🏿‍❤️‍👩🏿" },
		{ "👩🏿‍❤️‍👩🏿" }, { "👨‍❤️‍👨" }, { "👨‍❤️‍👨" }, { "👨🏻‍❤️‍👨🏻" }, { "👨🏻‍❤️‍👨🏻" },
		{ "👨🏻‍❤️‍👨🏼" }, { "👨🏻‍❤️‍👨🏼" }, { "👨🏻‍❤️‍👨🏽" }, { "👨🏻‍❤️‍👨🏽" },
		{ "👨🏻‍❤️‍👨🏾" }, { "👨🏻‍❤️‍👨🏾" }, { "👨🏻‍❤️‍👨🏿" }, { "👨🏻‍❤️‍👨🏿" },
		{ "👨🏼‍❤️‍👨🏻" }, { "👨🏼‍❤️‍👨🏻" }, { "👨🏼‍❤️‍👨🏼" }, { "👨🏼‍❤️‍👨🏼" },
		{ "👨🏼‍❤️‍👨🏽" }, { "👨🏼‍❤️‍👨🏽" }, { "👨🏼‍❤️‍👨🏾" }, { "👨🏼‍❤️‍👨🏾" },
		{ "👨🏼‍❤️‍👨🏿" }, { "👨🏼‍❤️‍👨🏿" }, { "👨🏽‍❤️‍👨🏻" }, { "👨🏽‍❤️‍👨🏻" },
		{ "👨🏽‍❤️‍👨🏼" }, { "👨🏽‍❤️‍👨🏼" }, { "👨🏽‍❤️‍👨🏽" }, { "👨🏽‍❤️‍👨🏽" },
		{ "👨🏽‍❤️‍👨🏾" }, { "👨🏽‍❤️‍👨🏾" }, { "👨🏽‍❤️‍👨🏿" }, { "👨🏽‍❤️‍👨🏿" },
		{ "👨🏾‍❤️‍👨🏻" }, { "👨🏾‍❤️‍👨🏻" }, { "👨🏾‍❤️‍👨🏼" }, { "👨🏾‍❤️‍👨🏼" },
		{ "👨🏾‍❤️‍👨🏽" }, { "👨🏾‍❤️‍👨🏽" }, { "👨🏾‍❤️‍👨🏾" }, { "👨🏾‍❤️‍👨🏾" },
		{ "👨🏾‍❤️‍👨🏿" }, { "👨🏾‍❤️‍👨🏿" }, { "👨🏿‍❤️‍👨🏻" }, { "👨🏿‍❤️‍👨🏻" },
		{ "👨🏿‍❤️‍👨🏼" }, { "👨🏿‍❤️‍👨🏼" }, { "👨🏿‍❤️‍👨🏽" }, { "👨🏿‍❤️‍👨🏽" },
		{ "👨🏿‍❤️‍👨🏾" }, { "👨🏿‍❤️‍👨🏾" }, { "👨🏿‍❤️‍👨🏿" }, { "👨🏿‍❤️‍👨🏿" }, { "💏" }, { "💏🏻" },
		{ "💏🏻" }, { "🧑🏻‍❤️‍💋‍🧑🏼" }, { "🧑🏻‍❤️‍💋‍🧑🏼" }, { "🧑🏻‍❤️‍💋‍🧑🏽" },
		{ "🧑🏻‍❤️‍💋‍🧑🏽" }, { "🧑🏻‍❤️‍💋‍🧑🏾" }, { "🧑🏻‍❤️‍💋‍🧑🏾" }, { "🧑🏻‍❤️‍💋‍🧑🏿" },
		{ "🧑🏻‍❤️‍💋‍🧑🏿" }, { "🧑🏼‍❤️‍💋‍🧑🏻" }, { "🧑🏼‍❤️‍💋‍🧑🏻" }, { "💏🏼" }, { "💏🏼" },
		{ "🧑🏼‍❤️‍💋‍🧑🏽" }, { "🧑🏼‍❤️‍💋‍🧑🏽" }, { "🧑🏼‍❤️‍💋‍🧑🏾" }, { "🧑🏼‍❤️‍💋‍🧑🏾" },
		{ "🧑🏼‍❤️‍💋‍🧑🏿" }, { "🧑🏼‍❤️‍💋‍🧑🏿" }, { "🧑🏽‍❤️‍💋‍🧑🏻" }, { "🧑🏽‍❤️‍💋‍🧑🏻" },
		{ "🧑🏽‍❤️‍💋‍🧑🏼" }, { "🧑🏽‍❤️‍💋‍🧑🏼" }, { "💏🏽" }, { "💏🏽" }, { "🧑🏽‍❤️‍💋‍🧑🏾" },
		{ "🧑🏽‍❤️‍💋‍🧑🏾" }, { "🧑🏽‍❤️‍💋‍🧑🏿" }, { "🧑🏽‍❤️‍💋‍🧑🏿" }, { "🧑🏾‍❤️‍💋‍🧑🏻" },
		{ "🧑🏾‍❤️‍💋‍🧑🏻" }, { "🧑🏾‍❤️‍💋‍🧑🏼" }, { "🧑🏾‍❤️‍💋‍🧑🏼" }, { "🧑🏾‍❤️‍💋‍🧑🏽" },
		{ "🧑🏾‍❤️‍💋‍🧑🏽" }, { "💏🏾" }, { "💏🏾" }, { "🧑🏾‍❤️‍💋‍🧑🏿" }, { "🧑🏾‍❤️‍💋‍🧑🏿" },
		{ "🧑🏿‍❤️‍💋‍🧑🏻" }, { "🧑🏿‍❤️‍💋‍🧑🏻" }, { "🧑🏿‍❤️‍💋‍🧑🏼" }, { "🧑🏿‍❤️‍💋‍🧑🏼" },
		{ "🧑🏿‍❤️‍💋‍🧑🏽" }, { "🧑🏿‍❤️‍💋‍🧑🏽" }, { "🧑🏿‍❤️‍💋‍🧑🏾" }, { "🧑🏿‍❤️‍💋‍🧑🏾" },
		{ "💏🏿" }, { "💏🏿" }, { "👩‍❤️‍💋‍👨" }, { "👩🏻‍❤️‍💋‍👨🏻" }, { "👩🏻‍❤️‍💋‍👨🏻" },
		{ "👩🏻‍❤️‍💋‍👨🏼" }, { "👩🏻‍❤️‍💋‍👨🏼" }, { "👩🏻‍❤️‍💋‍👨🏽" }, { "👩🏻‍❤️‍💋‍👨🏽" },
		{ "👩🏻‍❤️‍💋‍👨🏾" }, { "👩🏻‍❤️‍💋‍👨🏾" }, { "👩🏻‍❤️‍💋‍👨🏿" }, { "👩🏻‍❤️‍💋‍👨🏿" },
		{ "👩🏼‍❤️‍💋‍👨🏻" }, { "👩🏼‍❤️‍💋‍👨🏻" }, { "👩🏼‍❤️‍💋‍👨🏼" }, { "👩🏼‍❤️‍💋‍👨🏼" },
		{ "👩🏼‍❤️‍💋‍👨🏽" }, { "👩🏼‍❤️‍💋‍👨🏽" }, { "👩🏼‍❤️‍💋‍👨🏾" }, { "👩🏼‍❤️‍💋‍👨🏾" },
		{ "👩🏼‍❤️‍💋‍👨🏿" }, { "👩🏼‍❤️‍💋‍👨🏿" }, { "👩🏽‍❤️‍💋‍👨🏻" }, { "👩🏽‍❤️‍💋‍👨🏻" },
		{ "👩🏽‍❤️‍💋‍👨🏼" }, { "👩🏽‍❤️‍💋‍👨🏼" }, { "👩🏽‍❤️‍💋‍👨🏽" }, { "👩🏽‍❤️‍💋‍👨🏽" },
		{ "👩🏽‍❤️‍💋‍👨🏾" }, { "👩🏽‍❤️‍💋‍👨🏾" }, { "👩🏽‍❤️‍💋‍👨🏿" }, { "👩🏽‍❤️‍💋‍👨🏿" },
		{ "👩🏾‍❤️‍💋‍👨🏻" }, { "👩🏾‍❤️‍💋‍👨🏻" }, { "👩🏾‍❤️‍💋‍👨🏼" }, { "👩🏾‍❤️‍💋‍👨🏼" },
		{ "👩🏾‍❤️‍💋‍👨🏽" }, { "👩🏾‍❤️‍💋‍👨🏽" }, { "👩🏾‍❤️‍💋‍👨🏾" }, { "👩🏾‍❤️‍💋‍👨🏾" },
		{ "👩🏾‍❤️‍💋‍👨🏿" }, { "👩🏾‍❤️‍💋‍👨🏿" }, { "👩🏿‍❤️‍💋‍👨🏻" }, { "👩🏿‍❤️‍💋‍👨🏻" },
		{ "👩🏿‍❤️‍💋‍👨🏼" }, { "👩🏿‍❤️‍💋‍👨🏼" }, { "👩🏿‍❤️‍💋‍👨🏽" }, { "👩🏿‍❤️‍💋‍👨🏽" },
		{ "👩🏿‍❤️‍💋‍👨🏾" }, { "👩🏿‍❤️‍💋‍👨🏾" }, { "👩🏿‍❤️‍💋‍👨🏿" }, { "👩🏿‍❤️‍💋‍👨🏿" },
		{ "👩‍❤️‍💋‍👩" }, { "👩‍❤️‍💋‍👩" }, { "👩🏻‍❤️‍💋‍👩🏻" }, { "👩🏻‍❤️‍💋‍👩🏻" },
		{ "👩🏻‍❤️‍💋‍👩🏼" }, { "👩🏻‍❤️‍💋‍👩🏼" }, { "👩🏻‍❤️‍💋‍👩🏽" }, { "👩🏻‍❤️‍💋‍👩🏽" },
		{ "👩🏻‍❤️‍💋‍👩🏾" }, { "👩🏻‍❤️‍💋‍👩🏾" }, { "👩🏻‍❤️‍💋‍👩🏿" }, { "👩🏻‍❤️‍💋‍👩🏿" },
		{ "👩🏼‍❤️‍💋‍👩🏻" }, { "👩🏼‍❤️‍💋‍👩🏻" }, { "👩🏼‍❤️‍💋‍👩🏼" }, { "👩🏼‍❤️‍💋‍👩🏼" },
		{ "👩🏼‍❤️‍💋‍👩🏽" }, { "👩🏼‍❤️‍💋‍👩🏽" }, { "👩🏼‍❤️‍💋‍👩🏾" }, { "👩🏼‍❤️‍💋‍👩🏾" },
		{ "👩🏼‍❤️‍💋‍👩🏿" }, { "👩🏼‍❤️‍💋‍👩🏿" }, { "👩🏽‍❤️‍💋‍👩🏻" }, { "👩🏽‍❤️‍💋‍👩🏻" },
		{ "👩🏽‍❤️‍💋‍👩🏼" }, { "👩🏽‍❤️‍💋‍👩🏼" }, { "👩🏽‍❤️‍💋‍👩🏽" }, { "👩🏽‍❤️‍💋‍👩🏽" },
		{ "👩🏽‍❤️‍💋‍👩🏾" }, { "👩🏽‍❤️‍💋‍👩🏾" }, { "👩🏽‍❤️‍💋‍👩🏿" }, { "👩🏽‍❤️‍💋‍👩🏿" },
		{ "👩🏾‍❤️‍💋‍👩🏻" }, { "👩🏾‍❤️‍💋‍👩🏻" }, { "👩🏾‍❤️‍💋‍👩🏼" }, { "👩🏾‍❤️‍💋‍👩🏼" },
		{ "👩🏾‍❤️‍💋‍👩🏽" }, { "👩🏾‍❤️‍💋‍👩🏽" }, { "👩🏾‍❤️‍💋‍👩🏾" }, { "👩🏾‍❤️‍💋‍👩🏾" },
		{ "👩🏾‍❤️‍💋‍👩🏿" }, { "👩🏾‍❤️‍💋‍👩🏿" }, { "👩🏿‍❤️‍💋‍👩🏻" }, { "👩🏿‍❤️‍💋‍👩🏻" },
		{ "👩🏿‍❤️‍💋‍👩🏼" }, { "👩🏿‍❤️‍💋‍👩🏼" }, { "👩🏿‍❤️‍💋‍👩🏽" }, { "👩🏿‍❤️‍💋‍👩🏽" },
		{ "👩🏿‍❤️‍💋‍👩🏾" }, { "👩🏿‍❤️‍💋‍👩🏾" }, { "👩🏿‍❤️‍💋‍👩🏿" }, { "👩🏿‍❤️‍💋‍👩🏿" },
		{ "👨‍❤️‍💋‍👨" }, { "👨‍❤️‍💋‍👨" }, { "👨‍❤️‍💋‍👨" }, { "👨🏻‍❤️‍💋‍👨🏻" },
		{ "👨🏻‍❤️‍💋‍👨🏻" }, { "👨🏻‍❤️‍💋‍👨🏼" }, { "👨🏻‍❤️‍💋‍👨🏼" }, { "👨🏻‍❤️‍💋‍👨🏽" },
		{ "👨🏻‍❤️‍💋‍👨🏽" }, { "👨🏻‍❤️‍💋‍👨🏾" }, { "👨🏻‍❤️‍💋‍👨🏾" }, { "👨🏻‍❤️‍💋‍👨🏿" },
		{ "👨🏻‍❤️‍💋‍👨🏿" }, { "👨🏼‍❤️‍💋‍👨🏻" }, { "👨🏼‍❤️‍💋‍👨🏻" }, { "👨🏼‍❤️‍💋‍👨🏼" },
		{ "👨🏼‍❤️‍💋‍👨🏼" }, { "👨🏼‍❤️‍💋‍👨🏽" }, { "👨🏼‍❤️‍💋‍👨🏽" }, { "👨🏼‍❤️‍💋‍👨🏾" },
		{ "👨🏼‍❤️‍💋‍👨🏾" }, { "👨🏼‍❤️‍💋‍👨🏿" }, { "👨🏼‍❤️‍💋‍👨🏿" }, { "👨🏽‍❤️‍💋‍👨🏻" },
		{ "👨🏽‍❤️‍💋‍👨🏻" }, { "👨🏽‍❤️‍💋‍👨🏼" }, { "👨🏽‍❤️‍💋‍👨🏼" }, { "👨🏽‍❤️‍💋‍👨🏽" },
		{ "👨🏽‍❤️‍💋‍👨🏽" }, { "👨🏽‍❤️‍💋‍👨🏾" }, { "👨🏽‍❤️‍💋‍👨🏾" }, { "👨🏽‍❤️‍💋‍👨🏿" },
		{ "👨🏽‍❤️‍💋‍👨🏿" }, { "👨🏾‍❤️‍💋‍👨🏻" }, { "👨🏾‍❤️‍💋‍👨🏻" }, { "👨🏾‍❤️‍💋‍👨🏼" },
		{ "👨🏾‍❤️‍💋‍👨🏼" }, { "👨🏾‍❤️‍💋‍👨🏽" }, { "👨🏾‍❤️‍💋‍👨🏽" }, { "👨🏾‍❤️‍💋‍👨🏾" },
		{ "👨🏾‍❤️‍💋‍👨🏾" }, { "👨🏾‍❤️‍💋‍👨🏿" }, { "👨🏾‍❤️‍💋‍👨🏿" }, { "👨🏿‍❤️‍💋‍👨🏻" },
		{ "👨🏿‍❤️‍💋‍👨🏻" }, { "👨🏿‍❤️‍💋‍👨🏼" }, { "👨🏿‍❤️‍💋‍👨🏼" }, { "👨🏿‍❤️‍💋‍👨🏽" },
		{ "👨🏿‍❤️‍💋‍👨🏽" }, { "👨🏿‍❤️‍💋‍👨🏾" }, { "👨🏿‍❤️‍💋‍👨🏾" }, { "👨🏿‍❤️‍💋‍👨🏿" },
		{ "👨🏿‍❤️‍💋‍👨🏿" }, { "👪" }, { "👨‍👩‍👦" }, { "👨‍👩‍👧" }, { "👨‍👩‍👧‍👦" }, { "👨‍👩‍👦‍👦" },
		{ "👨‍👩‍👧‍👧" }, { "👩‍👩‍👦" }, { "👩‍👩‍👧" }, { "👩‍👩‍👧‍👦" }, { "👩‍👩‍👦‍👦" },
		{ "👩‍👩‍👧‍👧" }, { "👨‍👨‍👦" }, { "👨‍👨‍👧" }, { "👨‍👨‍👧‍👦" }, { "👨‍👨‍👦‍👦" },
		{ "👨‍👨‍👧‍👧" }, { "👩‍👦" }, { "👩‍👧" }, { "👩‍👧‍👦" }, { "👩‍👦‍👦" }, { "👩‍👧‍👧" }, { "👨‍👦" },
		{ "👨‍👧" }, { "👨‍👧‍👦" }, { "👨‍👦‍👦" }, { "👨‍👧‍👧" }, { "🪢" }, { "🧶" }, { "🧵" }, { "🪡" }, { "🧥" }, { "🥼" }, { "🦺" },
		{ "👚" }, { "👕" }, { "👕" }, { "👖" }, { "🩲" }, { "🩳" }, { "👔" }, { "👗" }, { "👙" }, { "🩱" }, { "👘" }, { "🥻" }, { "🩴" }, { "🥿" }, { "🥿" }, { "👠" }, { "👡" },
		{ "👡" }, { "👢" }, { "👢" }, { "👞" }, { "👟" }, { "👟" }, { "🥾" }, { "🧦" }, { "🧤" }, { "🧣" }, { "🎩" }, { "🎩" }, { "🧢" }, { "👒" }, { "🎓" }, { "⛑️" }, { "⛑️" },
		{ "🪖" }, { "👑" }, { "💍" }, { "👝" }, { "👝" }, { "👛" }, { "👜" }, { "💼" }, { "🎒" }, { "🎒" }, { "🧳" }, { "👓" }, { "👓" }, { "🕶️" }, { "🥽" }, { "🌂" }, { "🩷" },
		{ "❤️" }, { "❤️" }, { "🧡" }, { "💛" }, { "💚" }, { "🩵" }, { "💙" }, { "💜" }, { "🖤" }, { "🩶" }, { "🤍" }, { "🤎" }, { "💔" }, { "❣️" }, { "❣️" }, { "💕" }, { "💞" },
		{ "💓" }, { "💓" }, { "💗" }, { "💗" }, { "💖" }, { "💘" }, { "💝" }, { "❤️‍🩹" }, { "❤️‍🔥" }, { "💟" }, { "☮️" }, { "☮️" }, { "✝️" }, { "✝️" }, { "☪️" },
		{ "🕉️" }, { "☸️" }, { "🪯" }, { "✡️" }, { "🔯" }, { "🕎" }, { "☯️" }, { "☦️" }, { "🛐" }, { "🛐" }, { "⛎" }, { "♈" }, { "♉" }, { "♊" }, { "♋" }, { "♌" }, { "♍" },
		{ "♎" }, { "♏" }, { "♏" }, { "♐" }, { "♑" }, { "♒" }, { "♓" }, { "🆔" }, { "⚛️" }, { "⚛️" }, { "🉑" }, { "☢️" }, { "☢️" }, { "☣️" }, { "☣️" }, { "📴" }, { "📳" },
		{ "🈶" }, { "🈚" }, { "🈸" }, { "🈺" }, { "🈷️" }, { "✴️" }, { "🆚" }, { "💮" }, { "🉐" }, { "㊙️" }, { "㊗️" }, { "🈴" }, { "🈵" }, { "🈹" }, { "🈲" }, { "🅰️" }, { "🅱️" },
		{ "🆎" }, { "🆑" }, { "🅾️" }, { "🆘" }, { "❌" }, { "❌" }, { "⭕" }, { "🛑" }, { "🛑" }, { "⛔" }, { "📛" }, { "🚫" }, { "🚫" }, { "💢" }, { "♨️" }, { "♨️" }, { "🚷" },
		{ "🚯" }, { "🚯" }, { "🚳" }, { "🚱" }, { "🔞" }, { "📵" }, { "🚭" }, { "❗" }, { "❕" }, { "❓" }, { "❓" }, { "❔" }, { "‼️" }, { "⁉️" }, { "🔅" }, { "🔆" }, { "〽️" },
		{ "⚠️" }, { "🚸" }, { "🔱" }, { "⚜️" }, { "🔰" }, { "♻️" }, { "✅" }, { "🈯" }, { "💹" }, { "❇️" }, { "✳️" }, { "❎" }, { "🌐" }, { "💠" }, { "Ⓜ️" }, { "Ⓜ️" }, { "🌀" }, { "💤" },
		{ "🏧" }, { "🚾" }, { "🚾" }, { "♿" }, { "🅿️" }, { "🛗" }, { "🈳" }, { "🈂️" }, { "🛂" }, { "🛃" }, { "🛄" }, { "🛅" }, { "🛜" }, { "🚹" }, { "🚹" }, { "🚺" }, { "🚺" },
		{ "🚼" }, { "🚻" }, { "🚮" }, { "🎦" }, { "📶" }, { "📶" }, { "🈁" }, { "🔣" }, { "🔣" }, { "ℹ️" }, { "ℹ️" }, { "🔤" }, { "🔡" }, { "🔠" }, { "🆖" }, { "🆗" }, { "🆙" },
		{ "🆒" }, { "🆕" }, { "🆓" }, { "0️⃣" }, { "1️⃣" }, { "2️⃣" }, { "3️⃣" }, { "4️⃣" }, { "5️⃣" }, { "6️⃣" }, { "7️⃣" }, { "8️⃣" }, { "9️⃣" }, { "🔟" }, { "🔢" }, { "#️⃣" }, { "*️⃣" }, { "*️⃣" },
		{ "⏏️" }, { "⏏️" }, { "▶️" }, { "⏸️" }, { "⏸️" }, { "⏯️" }, { "⏹️" }, { "⏺️" }, { "⏭️" }, { "⏭️" }, { "⏮️" }, { "⏮️" }, { "⏩" }, { "⏪" }, { "⏫" }, { "⏬" }, { "◀️" }, { "🔼" },
		{ "🔽" }, { "➡️" }, { "➡️" }, { "⬅️" }, { "⬅️" }, { "⬆️" }, { "⬆️" }, { "⬇️" }, { "⬇️" }, { "↗️" }, { "↘️" }, { "↙️" }, { "↖️" }, { "↖️" }, { "↕️" }, { "↕️" }, { "↔️" }, { "↪️" }, { "↩️" },
		{ "⤴️" }, { "⤵️" }, { "🔀" }, { "🔁" }, { "🔂" }, { "🔄" }, { "🔃" }, { "🎵" }, { "🎶" }, { "🎶" }, { "➕" }, { "➖" }, { "➗" }, { "✖️" }, { "🟰" }, { "♾️" }, { "💲" },
		{ "💱" }, { "™️" }, { "™️" }, { "©️" }, { "®️" }, { "〰️" }, { "➰" }, { "➿" }, { "🔚" }, { "🔚" }, { "🔙" }, { "🔙" }, { "🔛" }, { "🔛" }, { "🔝" }, { "🔝" }, { "🔜" },
		{ "🔜" }, { "✔️" }, { "✔️" }, { "☑️" }, { "🔘" }, { "⚪" }, { "⚫" }, { "🔴" }, { "🔵" }, { "🟤" }, { "🟣" }, { "🟢" }, { "🟡" }, { "🟠" }, { "🔺" }, { "🔻" }, { "🔸" },
		{ "🔹" }, { "🔶" }, { "🔷" }, { "🔳" }, { "🔲" }, { "▪️" }, { "▫️" }, { "◾" }, { "◽" }, { "◼️" }, { "◻️" }, { "⬛" }, { "⬜" }, { "🟧" }, { "🟦" }, { "🟥" }, { "🟫" },
		{ "🟪" }, { "🟩" }, { "🟨" }, { "🔈" }, { "🔇" }, { "🔇" }, { "🔉" }, { "🔊" }, { "🔔" }, { "🔕" }, { "📣" }, { "📣" }, { "📢" }, { "🗨️" }, { "🗨️" }, { "👁‍🗨" },
		{ "💬" }, { "💭" }, { "🗯️" }, { "🗯️" }, { "♠️" }, { "♠️" }, { "♣️" }, { "♣️" }, { "♥️" }, { "♥️" }, { "♦️" }, { "♦️" }, { "🃏" }, { "🃏" }, { "🎴" }, { "🀄" }, { "🕐" }, { "🕐" },
		{ "🕑" }, { "🕑" }, { "🕒" }, { "🕒" }, { "🕓" }, { "🕓" }, { "🕔" }, { "🕔" }, { "🕕" }, { "🕕" }, { "🕖" }, { "🕖" }, { "🕗" }, { "🕗" }, { "🕘" }, { "🕘" }, { "🕙" },
		{ "🕙" }, { "🕚" }, { "🕚" }, { "🕛" }, { "🕛" }, { "🕜" }, { "🕜" }, { "🕝" }, { "🕝" }, { "🕞" }, { "🕞" }, { "🕟" }, { "🕟" }, { "🕠" }, { "🕠" }, { "🕡" }, { "🕡" },
		{ "🕢" }, { "🕢" }, { "🕣" }, { "🕣" }, { "🕤" }, { "🕤" }, { "🕥" }, { "🕥" }, { "🕦" }, { "🕦" }, { "🕧" }, { "🕧" }, { "♀️" }, { "♂️" }, { "⚧" }, { "⚕️" }, { "🇿" },
		{ "🇾" }, { "🇽" }, { "🇼" }, { "🇻" }, { "🇺" }, { "🇹" }, { "🇸" }, { "🇷" }, { "🇶" }, { "🇵" }, { "🇴" }, { "🇳" }, { "🇲" }, { "🇱" }, { "🇰" }, { "🇯" }, { "🇮" }, { "🇭" }, { "🇬" },
		{ "🇫" }, { "🇪" }, { "🇩" }, { "🇨" }, { "🇧" }, { "🇦" }, { "🚗" }, { "🚗" }, { "🚕" }, { "🚙" }, { "🛻" }, { "🚐" }, { "🚌" }, { "🚎" }, { "🏎️" }, { "🏎️" }, { "🚓" },
		{ "🚑" }, { "🚒" }, { "🚚" }, { "🚛" }, { "🚜" }, { "🦯" }, { "🦽" }, { "🦼" }, { "🩼" }, { "🛴" }, { "🛴" }, { "🚲" }, { "🚲" }, { "🛵" }, { "🛵" }, { "🏍️" }, { "🏍️" },
		{ "🛺" }, { "🛞" }, { "🚨" }, { "🚔" }, { "🚍" }, { "🚘" }, { "🚖" }, { "🚡" }, { "🚠" }, { "🚟" }, { "🚃" }, { "🚋" }, { "🚋" }, { "🚞" }, { "🚝" }, { "🚄" }, { "🚅" },
		{ "🚅" }, { "🚈" }, { "🚂" }, { "🚂" }, { "🚆" }, { "🚇" }, { "🚊" }, { "🚉" }, { "✈️" }, { "🛫" }, { "🛬" }, { "🛩️" }, { "🛩️" }, { "💺" }, { "🛰️" }, { "🚀" }, { "🛸" },
		{ "🚁" }, { "🛶" }, { "🛶" }, { "⛵" }, { "🚤" }, { "🛥️" }, { "🛥️" }, { "🛳️" }, { "🛳️" }, { "⛴️" }, { "🚢" }, { "🛟" }, { "⚓" }, { "🪝" }, { "⛽" }, { "⛽" }, { "🚧" },
		{ "🚦" }, { "🚥" }, { "🚏" }, { "🚏" }, { "🗺️" }, { "🗺️" }, { "🗿" }, { "🗿" }, { "🗽" }, { "🗼" }, { "🏰" }, { "🏰" }, { "🏯" }, { "🏟️" }, { "🎡" }, { "🎢" }, { "🎠" },
		{ "⛲" }, { "⛱️" }, { "⛱️" }, { "🏖️" }, { "🏖️" }, { "🏝️" }, { "🏝️" }, { "🏜️" }, { "🌋" }, { "⛰️" }, { "🏔️" }, { "🏔️" }, { "🗻" }, { "🏕️" }, { "⛺" }, { "🏠" }, { "🏡" },
		{ "🏘️" }, { "🏘️" }, { "🏘️" }, { "🏚️" }, { "🏚️" }, { "🛖" }, { "🏗️" }, { "🏗️" }, { "🏭" }, { "🏢" }, { "🏬" }, { "🏣" }, { "🏤" }, { "🏥" }, { "🏦" }, { "🏨" }, { "🏪" },
		{ "🏫" }, { "🏩" }, { "💒" }, { "🏛️" }, { "⛪" }, { "🕌" }, { "🕍" }, { "🛕" }, { "🕋" }, { "⛩️" }, { "🛤️" }, { "🛤️" }, { "🛣️" }, { "🗾" }, { "🗾" }, { "🎑" }, { "🏞️" },
		{ "🏞️" }, { "🌅" }, { "🌄" }, { "🌠" }, { "🌠" }, { "🎇" }, { "🎆" }, { "🌇" }, { "🌇" }, { "🌇" }, { "🌆" }, { "🏙️" }, { "🌃" }, { "🌌" }, { "🌉" }, { "🌁" } };
}